#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commdlg.h>
#include <shellapi.h>
#include <richedit.h>
#include <commctrl.h>
#include <shlobj.h>
#include "akelpad.h"
#include "edit.h"


//Process
HANDLE hHeap;
HANDLE hMutex=0;

//WinMain
HINSTANCE hInstance;
char *lpCmdLine;
wchar_t *wlpCmdLine;
int nCmdShow;
STARTUPINFO lpStartupInfo;
STARTUPINFOW lpStartupInfoW;

//Versions
BOOL bOldWindows;
BOOL bOldRichEdit;
BOOL bOldComctl32;

//Buffers
char buf[BUFFER_SIZE];
wchar_t wbuf[BUFFER_SIZE];
char buf2[BUFFER_SIZE];
wchar_t wbuf2[BUFFER_SIZE];
unsigned char pcTranslateBuffer[TRANSLATE_BUFFER_SIZE];

//Language
char szLangModule[MAX_PATH]="";
wchar_t wszLangModule[MAX_PATH]=L"";
HMODULE hLangLib;
int nLangModules=0;
LANGID wLangSystem;
LANGID wLangCodepageRecognition;

//INI
char szIniFile[MAX_PATH];
wchar_t wszIniFile[MAX_PATH];
int nSaveSettings=SS_REGISTRY;

//Main Window
HWND hMainWnd;
HWND hWndEdit;
HWND hDummyWindow;
HWND hStatus;
HWND hDlgModeless=0;
RECT rcMainWindow={CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT};
int nMainStyle=0;
int nLastMainSize=0;
int nStatusHeight=0;
HACCEL hMainAccel;
HICON hMainIcon;
HICON hIconEmpty;
HMENU hMainMenu;
HMENU hPopupMenu;
HMENU hPopupEdit;
HMENU hPopupView;

//Codepages
int codepages[65536];
BOOL bEnumCodePages=FALSE;
BOOL bDefaultBOM;
BOOL bCurrentBOM;
int nRecodeCodePage;
int nCurrentCodePage;
int nDefaultCodePage;
int nAnsiCodePage;
int nOemCodePage;

//Recent files
char szCurrentFile[MAX_PATH]="";
wchar_t wszCurrentFile[MAX_PATH]=L"";
char (*szRecentNames)[MAX_PATH]=NULL;
wchar_t (*wszRecentNames)[MAX_PATH]=NULL;
DWORD *szRecentPositions=NULL;
DWORD *szRecentCodepages=NULL;
int nRecentFiles=RECENTFILES_AMOUNT;

//Open/Save dialog
OPENFILENAME ofn;
OPENFILENAMEW ofnW;
char szFileBuffer[FILELIST_BUFFER_SIZE];
wchar_t wszFileBuffer[FILELIST_BUFFER_SIZE];
char szFilter[MAX_PATH];
wchar_t wszFilter[MAX_PATH];
BOOL bAutodetect=TRUE;
BOOL bSaveDlg;
DWORD dwOfnFlags;
BOOL bOfnBOM=FALSE;
int nOfnCodePage;
BOOL bNewLineDetected;
int nMsgCreate=AUTOANSWER_ASK;
int nMsgBinary=AUTOANSWER_ASK;
WNDPROC OldPreviewProc;

//Find/Replace dialog
DWORD ftflags=FR_DOWN;
BOOL bRecodeDlg;
BOOL bReplaceDlg;
int nReplaceCount;
int nSearchStrings=SEARCHSTRINGS_AMOUNT;
char *szFind_orig=NULL;
wchar_t *wszFind_orig=NULL;
char *szReplace_orig=NULL;
wchar_t *wszReplace_orig=NULL;
char *szFind=NULL;
wchar_t *wszFind=NULL;
char *szReplace=NULL;
wchar_t *wszReplace=NULL;

//Options dialog
PROPSHEETHEADER psh={0};
PROPSHEETHEADERW pshW={0};
PROPSHEETPAGE psp[2]={0};
PROPSHEETPAGEW pspW[2]={0};
HHOOK cbtHook;

//Font/Color
LOGFONT logfont;
LOGFONTW logfontW;
CHOOSEFONT cf;
CHOOSEFONTW cfW;
CHOOSECOLOR cc;
CHOOSECOLORW ccW;
COLORREF crBackground=RGB(0xFF, 0xFF, 0xFF);
COLORREF crFont=RGB(0x00, 0x00, 0x00);
COLORREF crCustColors[16]={0};

//Print
PAGESETUPDLG psdPage={0};
PAGESETUPDLGW psdPageW={0};
PRINTDLG pd={0};
PRINTDLGW pdW={0};
BOOL bGlobalPrint=FALSE;

//Edit position
CHARRANGE chrg={0, 0};
int nPosition=0;
int nPositionOld=0;
int nMaxChars=0x0FFFFFFF;
int nMcstep=0x0FFFFFFF;

//Edit state
BOOL bModified=FALSE;
BOOL bInsertState=FALSE;
int nNewLine=NEWLINE_WIN;
BOOL bWordWrap=FALSE;
BOOL bOnTop=FALSE;
BOOL bStatusBar=TRUE;
BOOL bSaveTime=FALSE;
BOOL bWatchFile=FALSE;
BOOL bSingleOpenFile=FALSE;
BOOL bSingleOpenProgram=TRUE;
BOOL bKeepSpace=FALSE;
int nTabStopSize=EDIT_TABSTOPS;
BOOL bTabStopAsSpaces=FALSE;
DWORD dwEditMargins=EDIT_MARGINS;
FILETIME ft={0};
WNDPROC OldEditProc;

//Word breaking
wchar_t wszDelimiters[DELIMITERS_SIZE]=WORD_DELIMITERSW;
BOOL bFirstWordBreak=TRUE;

//Execute
char szCommand[BUFFER_SIZE]="";
wchar_t wszCommand[BUFFER_SIZE]=L"";
char szWorkDir[MAX_PATH]="";
wchar_t wszWorkDir[MAX_PATH]=L"";
char szExeDir[MAX_PATH]="";
wchar_t wszExeDir[MAX_PATH]=L"";

//Associations
char szFileTypesOpen[MAX_PATH]=ASSOCIATE_OPEN;
wchar_t wszFileTypesOpen[MAX_PATH]=ASSOCIATE_OPENW;
char szFileTypesEdit[MAX_PATH]=ASSOCIATE_EDIT;
wchar_t wszFileTypesEdit[MAX_PATH]=ASSOCIATE_EDITW;
char szFileTypesPrint[MAX_PATH]=ASSOCIATE_PRINT;
wchar_t wszFileTypesPrint[MAX_PATH]=ASSOCIATE_PRINTW;
DWORD dwFileTypesAssociated=0;

//Registered messages
UINT uiOpenOnStartMessage;

//OLE Drag'n'Drop
IRichEditOleCallbackVtbl REOLEVtbl={
  REOLE_QueryInterface,
  REOLE_AddRef,
  REOLE_Release,
  REOLE_GetNewStorage,
  REOLE_GetInPlaceContext,
  REOLE_ShowContainerUI,
  REOLE_QueryInsertObject,
  REOLE_DeleteObject,
  REOLE_QueryAcceptData,
  REOLE_ContextSensitiveHelp,
  REOLE_GetClipboardData,
  REOLE_GetDragDropEffect,
  REOLE_GetContextMenu
};
REOLE rl={&REOLEVtbl, 0};

//Mdi
BOOL bMDI=FALSE;
BOOL bRegMDI=FALSE;
HWND hMdiClient;
HWND hWndMdiActive=0;
HWND hWndMdiDestroyed=0;
BOOL bMdiMaximize;
BOOL bMdiNoWindows=FALSE;
BOOL bMdiReopen=FALSE;
HWND hTab;
HFONT hTabFont;
LOGFONT tabfont;
LOGFONTW tabfontW;
int nTabView=TAB_VIEW_TOP;
int nTabType=TAB_TYPE_STANDART;
HIMAGELIST hImageList;
BOOL bTabPressed=FALSE;
BOOL bFileExitError;
int nMdiStyle=WS_MAXIMIZE;
WNDPROC OldMdiClientProc;
WNDPROC OldTabProc;
MDIWINDOWDATA *lpWindowData;

//GetProcAddress
BOOL (WINAPI *GetCPInfoExAPtr) (UINT, DWORD, LPCPINFOEXA);
BOOL (WINAPI *GetCPInfoExWPtr) (UINT, DWORD, LPCPINFOEXW);
DWORD (WINAPI *GetLongPathNameAPtr) (LPCTSTR, LPTSTR, DWORD);
DWORD (WINAPI *GetLongPathNameWPtr) (LPCWSTR, LPWSTR, DWORD);
UINT (WINAPI *ExtractIconExAPtr) (LPCTSTR, int, HICON *, HICON *, UINT);
UINT (WINAPI *ExtractIconExWPtr) (LPCWSTR, int, HICON *, HICON *, UINT);
BOOL (WINAPI *SHGetPathFromIDListAPrt) (LPCITEMIDLIST, LPTSTR);
BOOL (WINAPI *SHGetPathFromIDListWPrt) (LPCITEMIDLIST, LPWSTR);
LPITEMIDLIST (WINAPI *SHBrowseForFolderAPrt) (LPBROWSEINFOA);
LPITEMIDLIST (WINAPI *SHBrowseForFolderWPrt) (LPBROWSEINFOW);


void _WinMain()
{
  MSG msg;
  BOOL msgstatus;
  HMODULE hKernel32=0;
  HMODULE hShell32=0;
  HMODULE hRTFLib=0;
  HWND hWndFriend=0;
  WORD wAtom;
  BOOL bExit=FALSE;
  int nMajor;
  int nMinor;
  int nRelease;
  int nBuild;
  int i;

  //Process
  hHeap=GetProcessHeap();

  //Is unicode Windows
  if (GetWindowsDirectoryW(NULL, 0))
    bOldWindows=FALSE;
  else
    bOldWindows=TRUE;

  if (bOldWindows)
  {
    WNDCLASS wndclass={0};
    char *pCmdLine;
    char *pFileName;

    //Set default options before reading from registry
    GetObject(GetStockObject(SYSTEM_FONT), sizeof(LOGFONT), &logfont);
    nAnsiCodePage=GetACP();
    nOemCodePage=GetOEMCP();
    nDefaultCodePage=nAnsiCodePage;
    nRecodeCodePage=nOemCodePage;
    bDefaultBOM=FALSE;
    wLangCodepageRecognition=wLangSystem=GetUserDefaultLangID();

    if (GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_IMEASURE, buf, 16))
    {
      if (*buf == '0')
      {
        psdPage.rtMargin.left=1000;
        psdPage.rtMargin.right=1000;
        psdPage.rtMargin.top=1000;
        psdPage.rtMargin.bottom=1000;
        psdPage.Flags=PSD_INHUNDREDTHSOFMILLIMETERS;
      }
      else
      {
        psdPage.rtMargin.left=500;
        psdPage.rtMargin.right=500;
        psdPage.rtMargin.top=500;
        psdPage.rtMargin.bottom=500;
        psdPage.Flags=PSD_INTHOUSANDTHSOFINCHES;
      }
    }

    //Get program HINSTANCE
    hInstance=GetModuleHandle(NULL);

    //Get program directory
    i=GetModuleFileName(hInstance, szExeDir, MAX_PATH);
    while (i > 0 && szExeDir[i] != '\\') --i;
    szExeDir[i]='\0';

    //Read options
    wsprintf(szIniFile, "%s\\AkelPad.ini", szExeDir);
    if (FileExistsA(szIniFile))
      GetPrivateProfileDWORDA("Options", "SaveSettings", (LPDWORD)&nSaveSettings, szIniFile);

    if (nSaveSettings == SS_REGISTRY)
      RegReadOptionsA();
    else
      IniReadOptionsA();

    if (nDefaultCodePage == CP_UNICODE_UCS2_LE || nDefaultCodePage == CP_UNICODE_UCS2_BE || nDefaultCodePage == CP_UNICODE_UTF8)
      bDefaultBOM=TRUE;
    bCurrentBOM=bDefaultBOM;
    nCurrentCodePage=nDefaultCodePage;
    bMDI=bRegMDI;

    //Get startup info
    lpStartupInfo.cb=sizeof(STARTUPINFO);
    GetStartupInfo(&lpStartupInfo);
    nCmdShow=lpStartupInfo.wShowWindow;
    if (!nCmdShow) nCmdShow=SW_SHOWNORMAL;

    //Mutex
    if (!(lpStartupInfo.dwFlags & STARTF_NOMUTEX))
    {
      if (hMutex=CreateMutex(NULL, TRUE, APP_MUTEX))
      {
        if (GetLastError() == ERROR_ALREADY_EXISTS)
        {
          WaitForSingleObject(hMutex, INFINITE);
          ReleaseMutex(hMutex);
          CloseHandle(hMutex);
          hMutex=0;
        }
      }
    }

    //Get command line
    pCmdLine=lpCmdLine=GetCommandLineParamsA();

    //Get rich edit version
    GetFileVersionA("riched20.dll", &nMajor, &nMinor, &nRelease, &nBuild);
    if (nMajor < 5 || (nMajor == 5 && nMinor < 30))
      bOldRichEdit=TRUE;
    else
      bOldRichEdit=FALSE;

    //Get common controls version
    GetFileVersionA("comctl32.dll", &nMajor, &nMinor, &nRelease, &nBuild);
    if (nMajor < 4 || (nMajor == 4 && nMinor < 71))
      bOldComctl32=TRUE;
    else
      bOldComctl32=FALSE;

    //Get functions addresses
    hKernel32=GetModuleHandle("kernel32.dll");
    GetCPInfoExAPtr=(BOOL(WINAPI *)(UINT, DWORD, LPCPINFOEXA))GetProcAddress(hKernel32, "GetCPInfoExA");
    GetLongPathNameAPtr=(DWORD(WINAPI *)(LPCTSTR, LPTSTR, DWORD))GetProcAddress(hKernel32, "GetLongPathNameA");

    hShell32=GetModuleHandle("shell32.dll");
    ExtractIconExAPtr=(UINT(WINAPI *)(LPCTSTR, int, HICON *, HICON *, UINT))GetProcAddress(hShell32, "ExtractIconExA");
    SHGetPathFromIDListAPrt=(BOOL(WINAPI *)(LPCITEMIDLIST, LPTSTR))GetProcAddress(hShell32, "SHGetPathFromIDListA");
    SHBrowseForFolderAPrt=(LPITEMIDLIST(WINAPI *)(LPBROWSEINFOA))GetProcAddress(hShell32, "SHBrowseForFolderA");

    //Get command line arguments
    if (bMDI)
    {
      if (bSingleOpenProgram)
      {
        if (hWndFriend=FindWindow(APP_MAIN_CLASS, NULL))
        {
          if (GetWindowLong(hWndFriend, GWL_STYLE) & WS_MINIMIZE)
            ShowWindow(hWndFriend, SW_RESTORE);
          else
            SetForegroundWindow(hWndFriend);
          bExit=TRUE;
        }
      }
      if (!hWndFriend && *pCmdLine)
      {
        if (hWndFriend=DoFileNewWindowA(STARTF_NOMUTEX))
          bExit=TRUE;
      }
    }

    if (*pCmdLine)
    {
      while (GetCommandLineArgA(pCmdLine, buf, &pCmdLine))
      {
        if (!lstrcmpi(buf, "/P"))
        {
          bGlobalPrint=TRUE;
          continue;
        }
        if (!lstrcmpi(buf, "/C+"))
        {
          nMsgCreate=AUTOANSWER_YES;
          continue;
        }
        if (!lstrcmpi(buf, "/C-"))
        {
          nMsgCreate=AUTOANSWER_NO;
          continue;
        }
        if (!lstrcmpi(buf, "/B+"))
        {
          nMsgBinary=AUTOANSWER_YES;
          continue;
        }
        if (!lstrcmpi(buf, "/B-"))
        {
          nMsgBinary=AUTOANSWER_NO;
          continue;
        }
        if (!*buf) continue;
        lstrcpy(szFileBuffer, buf);

        if (!bMDI)
        {
          if (bSingleOpenFile)
          {
            if (FileExistsA(szFileBuffer))
            {
              GetFullPathName(szFileBuffer, BUFFER_SIZE, buf, &pFileName);
              if (GetLongPathNameAPtr) (*GetLongPathNameAPtr)(buf, szFileBuffer, MAX_PATH);
              else lstrcpy(szFileBuffer, buf);

              if ((hWndFriend=FindWindow(APP_SDI_CLASS, szFileBuffer)) &&
                  (hWndFriend=GetParent(hWndFriend)))
              {
                SetForegroundWindow(hWndFriend);
                if (!*pCmdLine) goto Quit;
                continue;
              }
            }
          }
          if (!*pCmdLine) break;

          hWndFriend=DoFileNewWindowA(STARTF_NOMUTEX);
        }
        if (hWndFriend)
        {
          if (bGlobalPrint) SendMessage(hWndFriend, WM_COMMAND, IDM_NONMENU_SETFILEPRINT, 0);
          if (nMsgCreate != AUTOANSWER_ASK) SendMessage(hWndFriend, WM_COMMAND, IDM_NONMENU_SETMSGCREATE, (LPARAM)nMsgCreate);
          if (nMsgBinary != AUTOANSWER_ASK) SendMessage(hWndFriend, WM_COMMAND, IDM_NONMENU_SETMSGBINARY, (LPARAM)nMsgBinary);

          wAtom=GlobalAddAtom(szFileBuffer);
          SendMessage(hWndFriend, WM_COMMAND, MAKELONG(IDM_NONMENU_FILEOPEN, wAtom), MAKELONG(ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0));
          GlobalDeleteAtom(wAtom);
        }
      }
    }
    if (bExit) goto Quit;

    //GetOpenFileName dialog file filters
    API_LoadStringA(hLangLib, STR_FILE_FILTER, szFilter, MAX_PATH);
    for (i=0; szFilter[i]; ++i)
      if (szFilter[i] == '|') szFilter[i]='\0';
    szFilter[++i]='\0';

    //Load DLL's
    if (*szLangModule)
    {
      wsprintf(buf, "%s\\AkelFiles\\Langs\\%s", szExeDir, szLangModule);

      if (!(hLangLib=LoadLibrary(buf)))
      {
        hLangLib=hInstance;
        API_LoadStringA(hLangLib, MSG_ERROR_LOADING_LANG_DLL, buf, BUFFER_SIZE);
        wsprintf(buf2, buf, szLangModule);
        MessageBox(NULL, buf2, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
      }
    }
    else hLangLib=hInstance;

    if (!(hRTFLib=LoadLibrary("riched20.dll")))
    {
      API_LoadStringA(hLangLib, MSG_ERROR_LOADING_RICHEDIT_DLL, buf, BUFFER_SIZE);
      MessageBox(NULL, buf, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
      goto Quit;
    }

    uiOpenOnStartMessage=RegisterWindowMessage(APP_REGMSG);
    InitCommonControls();

    hMainAccel=API_LoadAcceleratorsA(hLangLib, MAKEINTRESOURCE(IDM_MENU_MAIN));
    hMainIcon=API_LoadIconA(hLangLib, MAKEINTRESOURCE(IDI_ICON_MAIN));
    hIconEmpty=(HICON)API_LoadImageA(hLangLib, MAKEINTRESOURCE(IDI_ICON_EMPTY), IMAGE_ICON, 0, 0, 0);
    hMainMenu=API_LoadMenuA(hLangLib, MAKEINTRESOURCE(IDM_MENU_MAIN));
    hPopupMenu=API_LoadMenuA(hLangLib, MAKEINTRESOURCE(IDM_MENU_POPUP));

    wndclass.style        =CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
    wndclass.lpfnWndProc  =WndProcA;
    wndclass.cbClsExtra   =0;
    wndclass.cbWndExtra   =DLGWINDOWEXTRA;
    wndclass.hInstance    =hInstance;
    wndclass.hIcon        =hMainIcon;
    wndclass.hCursor      =NULL;
    wndclass.hbrBackground=(HBRUSH)GetStockObject(HOLLOW_BRUSH);
    wndclass.lpszMenuName =MAKEINTRESOURCE(IDM_MENU_MAIN);
    wndclass.lpszClassName=APP_MAIN_CLASS;
    if (!RegisterClass(&wndclass)) goto Quit;

    if (!bMDI)
    {
      wndclass.style        =0;
      wndclass.lpfnWndProc  =DummyWndProcA;
      wndclass.cbClsExtra   =0;
      wndclass.cbWndExtra   =DLGWINDOWEXTRA;
      wndclass.hInstance    =hInstance;
      wndclass.hIcon        =NULL;
      wndclass.hCursor      =NULL;
      wndclass.hbrBackground=NULL;
      wndclass.lpszMenuName =NULL;
      wndclass.lpszClassName=APP_SDI_CLASS;
      if (!RegisterClass(&wndclass)) goto Quit;
    }
    else
    {
      wndclass.style        =CS_HREDRAW|CS_VREDRAW;
      wndclass.lpfnWndProc  =MdiProcA;
      wndclass.cbClsExtra   =0;
      wndclass.cbWndExtra   =DLGWINDOWEXTRA;
      wndclass.hInstance    =hInstance;
      wndclass.hIcon        =NULL;
      wndclass.hCursor      =NULL;
      wndclass.hbrBackground=NULL;
      wndclass.lpszMenuName =NULL;
      wndclass.lpszClassName=APP_MDI_CLASS;
      if (!RegisterClass(&wndclass)) goto Quit;
    }

    hMainWnd=CreateWindow(APP_MAIN_CLASS,        // window class name
                          APP_MAIN_TITLE,        // window caption
                          WS_OVERLAPPEDWINDOW,   // window style
                          rcMainWindow.left,     // initial x position
                          rcMainWindow.top,      // initial y position
                          rcMainWindow.right,    // initial x size
                          rcMainWindow.bottom,   // initial y size
                          NULL,                  // parent window handle
                          hMainMenu,             // window menu handle
                          hInstance,             // program instance handle
                          NULL);                 // creation parameters
    if (!hMainWnd) goto Quit;

    UpdateWindow(hMainWnd);

    while ((msgstatus=GetMessage(&msg, NULL, 0, 0)) && msgstatus != -1)
    {
      if (hDlgModeless == 0 || !IsDialogMessage(hDlgModeless, &msg))
      {
        if (!TranslateAccelerator(hMainWnd, hMainAccel, &msg))
        {
          TranslateMessage(&msg);
          DispatchMessage(&msg);
        }
      }
    }
    if (msgstatus == -1)
    {
      API_LoadStringA(hLangLib, MSG_ERROR_IN_MESSAGE_QUEUE, buf, BUFFER_SIZE);
      MessageBox(NULL, buf, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
    }
  }
  else
  {
    WNDCLASSW wndclassW={0};
    wchar_t *wpCmdLine;
    wchar_t *wpFileName;

    //Set default options before reading from registry
    GetObjectW(GetStockObject(SYSTEM_FONT), sizeof(LOGFONTW), &logfontW);
    nAnsiCodePage=GetACP();
    nOemCodePage=GetOEMCP();
    nDefaultCodePage=nAnsiCodePage;
    nRecodeCodePage=nOemCodePage;
    bDefaultBOM=FALSE;
    wLangCodepageRecognition=wLangSystem=GetUserDefaultLangID();

    if (GetLocaleInfoW(LOCALE_USER_DEFAULT, LOCALE_IMEASURE, wbuf, 16))
    {
      if (*wbuf == '0')
      {
        psdPageW.rtMargin.left=1000;
        psdPageW.rtMargin.right=1000;
        psdPageW.rtMargin.top=1000;
        psdPageW.rtMargin.bottom=1000;
        psdPageW.Flags=PSD_INHUNDREDTHSOFMILLIMETERS;
      }
      else
      {
        psdPageW.rtMargin.left=500;
        psdPageW.rtMargin.right=500;
        psdPageW.rtMargin.top=500;
        psdPageW.rtMargin.bottom=500;
        psdPageW.Flags=PSD_INTHOUSANDTHSOFINCHES;
      }
    }

    //Get program HINSTANCE
    hInstance=GetModuleHandleW(NULL);

    //Get program directory
    i=GetModuleFileNameW(hInstance, wszExeDir, MAX_PATH);
    while (i > 0 && wszExeDir[i] != '\\') --i;
    wszExeDir[i]='\0';

    //Read options
    wsprintfW(wszIniFile, L"%s\\AkelPad.ini", wszExeDir);
    if (FileExistsW(wszIniFile))
      GetPrivateProfileDWORDW(L"Options", L"SaveSettings", (LPDWORD)&nSaveSettings, wszIniFile);

    if (nSaveSettings == SS_REGISTRY)
      RegReadOptionsW();
    else
      IniReadOptionsW();

    if (nDefaultCodePage == CP_UNICODE_UCS2_LE || nDefaultCodePage == CP_UNICODE_UCS2_BE || nDefaultCodePage == CP_UNICODE_UTF8)
      bDefaultBOM=TRUE;
    bCurrentBOM=bDefaultBOM;
    nCurrentCodePage=nDefaultCodePage;
    bMDI=bRegMDI;

    //Get startup info
    lpStartupInfoW.cb=sizeof(STARTUPINFOW);
    GetStartupInfoW(&lpStartupInfoW);
    nCmdShow=lpStartupInfoW.wShowWindow;
    if (!nCmdShow) nCmdShow=SW_SHOWNORMAL;

    //Mutex
    if (!(lpStartupInfoW.dwFlags & STARTF_NOMUTEX))
    {
      if (hMutex=CreateMutex(NULL, TRUE, APP_MUTEX))
      {
        if (GetLastError() == ERROR_ALREADY_EXISTS)
        {
          WaitForSingleObject(hMutex, INFINITE);
          ReleaseMutex(hMutex);
          CloseHandle(hMutex);
          hMutex=0;
        }
      }
    }

    //Get command line
    wpCmdLine=wlpCmdLine=GetCommandLineParamsW();

    //Get rich edit version
    GetFileVersionW(L"riched20.dll", &nMajor, &nMinor, &nRelease, &nBuild);
    if (nMajor < 5 || (nMajor == 5 && nMinor < 30))
      bOldRichEdit=TRUE;
    else
      bOldRichEdit=FALSE;

    //Get common controls version
    GetFileVersionW(L"comctl32.dll", &nMajor, &nMinor, &nRelease, &nBuild);
    if (nMajor < 4 || (nMajor == 4 && nMinor < 71))
      bOldComctl32=TRUE;
    else
      bOldComctl32=FALSE;

    //Get functions addresses
    hKernel32=GetModuleHandleW(L"kernel32.dll");
    GetCPInfoExWPtr=(BOOL(WINAPI *)(UINT, DWORD, LPCPINFOEXW))GetProcAddress(hKernel32, "GetCPInfoExW");
    GetLongPathNameWPtr=(DWORD(WINAPI *)(LPCWSTR, LPWSTR, DWORD))GetProcAddress(hKernel32, "GetLongPathNameW");

    hShell32=GetModuleHandleW(L"shell32.dll");
    ExtractIconExWPtr=(UINT(WINAPI *)(LPCWSTR, int, HICON *, HICON *, UINT))GetProcAddress(hShell32, "ExtractIconExW");
    SHGetPathFromIDListWPrt=(BOOL(WINAPI *)(LPCITEMIDLIST, LPWSTR))GetProcAddress(hShell32, "SHGetPathFromIDListW");
    SHBrowseForFolderWPrt=(LPITEMIDLIST(WINAPI *)(LPBROWSEINFOW))GetProcAddress(hShell32, "SHBrowseForFolderW");

    //Get command line arguments
    if (bMDI)
    {
      if (bSingleOpenProgram)
      {
        if (hWndFriend=FindWindowW(APP_MAIN_CLASSW, NULL))
        {
          if (GetWindowLong(hWndFriend, GWL_STYLE) & WS_MINIMIZE)
            ShowWindow(hWndFriend, SW_RESTORE);
          else
            SetForegroundWindow(hWndFriend);
          bExit=TRUE;
        }
      }
      if (!hWndFriend && *wpCmdLine)
      {
        if (hWndFriend=DoFileNewWindowW(STARTF_NOMUTEX))
          bExit=TRUE;
      }
    }

    if (*wpCmdLine)
    {
      while (GetCommandLineArgW(wpCmdLine, wbuf, &wpCmdLine))
      {
        if (!lstrcmpiW(wbuf, L"/P"))
        {
          bGlobalPrint=TRUE;
          continue;
        }
        if (!lstrcmpiW(wbuf, L"/C+"))
        {
          nMsgCreate=AUTOANSWER_YES;
          continue;
        }
        if (!lstrcmpiW(wbuf, L"/C-"))
        {
          nMsgCreate=AUTOANSWER_NO;
          continue;
        }
        if (!lstrcmpiW(wbuf, L"/B+"))
        {
          nMsgBinary=AUTOANSWER_YES;
          continue;
        }
        if (!lstrcmpiW(wbuf, L"/B-"))
        {
          nMsgBinary=AUTOANSWER_NO;
          continue;
        }
        if (!*wbuf) continue;
        lstrcpyW(wszFileBuffer, wbuf);

        if (!bMDI)
        {
          if (bSingleOpenFile)
          {
            if (FileExistsW(wszFileBuffer))
            {
              GetFullPathNameW(wszFileBuffer, BUFFER_SIZE, wbuf, &wpFileName);
              if (GetLongPathNameWPtr) (*GetLongPathNameWPtr)(wbuf, wszFileBuffer, MAX_PATH);
              else lstrcpyW(wszFileBuffer, wbuf);

              if ((hWndFriend=FindWindowW(APP_SDI_CLASSW, wszFileBuffer)) &&
                  (hWndFriend=GetParent(hWndFriend)))
              {
                SetForegroundWindow(hWndFriend);
                if (!*wpCmdLine) goto Quit;
                continue;
              }
            }
          }
          if (!*wpCmdLine) break;

          hWndFriend=DoFileNewWindowW(STARTF_NOMUTEX);
        }
        if (hWndFriend)
        {
          if (bGlobalPrint) SendMessage(hWndFriend, WM_COMMAND, IDM_NONMENU_SETFILEPRINT, 0);
          if (nMsgCreate != AUTOANSWER_ASK) SendMessage(hWndFriend, WM_COMMAND, IDM_NONMENU_SETMSGCREATE, (LPARAM)nMsgCreate);
          if (nMsgBinary != AUTOANSWER_ASK) SendMessage(hWndFriend, WM_COMMAND, IDM_NONMENU_SETMSGBINARY, (LPARAM)nMsgBinary);

          wAtom=GlobalAddAtomW(wszFileBuffer);
          SendMessage(hWndFriend, WM_COMMAND, MAKELONG(IDM_NONMENU_FILEOPEN, wAtom), MAKELONG(ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0));
          GlobalDeleteAtom(wAtom);
        }
      }
    }
    if (bExit) goto Quit;

    //GetOpenFileName dialog file filters
    API_LoadStringW(hLangLib, STR_FILE_FILTER, wszFilter, MAX_PATH);
    for (i=0; wszFilter[i]; ++i)
      if (wszFilter[i] == '|') wszFilter[i]='\0';
    wszFilter[++i]='\0';

    //Load DLL's
    if (*wszLangModule)
    {
      wsprintfW(wbuf, L"%s\\AkelFiles\\Langs\\%s", wszExeDir, wszLangModule);

      if (!(hLangLib=LoadLibraryW(wbuf)))
      {
        hLangLib=hInstance;
        API_LoadStringW(hLangLib, MSG_ERROR_LOADING_LANG_DLL, wbuf, BUFFER_SIZE);
        wsprintfW(wbuf2, wbuf, wszLangModule);
        MessageBoxW(NULL, wbuf2, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
      }
    }
    else hLangLib=hInstance;

    if (!(hRTFLib=LoadLibraryW(L"riched20.dll")))
    {
      API_LoadStringW(hLangLib, MSG_ERROR_LOADING_RICHEDIT_DLL, wbuf, BUFFER_SIZE);
      MessageBoxW(NULL, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
      goto Quit;
    }

    uiOpenOnStartMessage=RegisterWindowMessage(APP_REGMSG);
    InitCommonControls();

    hMainAccel=API_LoadAcceleratorsW(hLangLib, MAKEINTRESOURCEW(IDM_MENU_MAIN));
    hMainIcon=API_LoadIconW(hLangLib, MAKEINTRESOURCEW(IDI_ICON_MAIN));
    hIconEmpty=(HICON)API_LoadImageW(hLangLib, MAKEINTRESOURCEW(IDI_ICON_EMPTY), IMAGE_ICON, 0, 0, 0);
    hMainMenu=API_LoadMenuW(hLangLib, MAKEINTRESOURCEW(IDM_MENU_MAIN));
    hPopupMenu=API_LoadMenuW(hLangLib, MAKEINTRESOURCEW(IDM_MENU_POPUP));

    wndclassW.style        =CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
    wndclassW.lpfnWndProc  =WndProcW;
    wndclassW.cbClsExtra   =0;
    wndclassW.cbWndExtra   =DLGWINDOWEXTRA;
    wndclassW.hInstance    =hInstance;
    wndclassW.hIcon        =hMainIcon;
    wndclassW.hCursor      =NULL;
    wndclassW.hbrBackground=(HBRUSH)GetStockObject(HOLLOW_BRUSH);
    wndclassW.lpszMenuName =MAKEINTRESOURCEW(IDM_MENU_MAIN);
    wndclassW.lpszClassName=APP_MAIN_CLASSW;
    if (!RegisterClassW(&wndclassW)) goto Quit;

    if (!bMDI)
    {
      wndclassW.style        =0;
      wndclassW.lpfnWndProc  =DummyWndProcW;
      wndclassW.cbClsExtra   =0;
      wndclassW.cbWndExtra   =DLGWINDOWEXTRA;
      wndclassW.hInstance    =hInstance;
      wndclassW.hIcon        =NULL;
      wndclassW.hCursor      =NULL;
      wndclassW.hbrBackground=NULL;
      wndclassW.lpszMenuName =NULL;
      wndclassW.lpszClassName=APP_SDI_CLASSW;
      if (!RegisterClassW(&wndclassW)) goto Quit;
    }
    else
    {
      wndclassW.style        =CS_HREDRAW|CS_VREDRAW;
      wndclassW.lpfnWndProc  =MdiProcW;
      wndclassW.cbClsExtra   =0;
      wndclassW.cbWndExtra   =DLGWINDOWEXTRA;
      wndclassW.hInstance    =hInstance;
      wndclassW.hIcon        =NULL;
      wndclassW.hCursor      =NULL;
      wndclassW.hbrBackground=NULL;
      wndclassW.lpszMenuName =NULL;
      wndclassW.lpszClassName=APP_MDI_CLASSW;
      if (!RegisterClassW(&wndclassW)) goto Quit;
    }

    hMainWnd=CreateWindowW(APP_MAIN_CLASSW,       // window class name
                           APP_MAIN_TITLEW,       // window caption
                           WS_OVERLAPPEDWINDOW,   // window style
                           rcMainWindow.left,     // initial x position
                           rcMainWindow.top,      // initial y position
                           rcMainWindow.right,    // initial x size
                           rcMainWindow.bottom,   // initial y size
                           NULL,                  // parent window handle
                           hMainMenu,             // window menu handle
                           hInstance,             // program instance handle
                           NULL);                 // creation parameters
    if (!hMainWnd) goto Quit;

    UpdateWindow(hMainWnd);

    while ((msgstatus=GetMessageW(&msg, NULL, 0, 0)) && msgstatus != -1)
    {
      if (hDlgModeless == 0 || !IsDialogMessageW(hDlgModeless, &msg))
      {
        if (!TranslateAcceleratorW(hMainWnd, hMainAccel, &msg))
        {
          TranslateMessage(&msg);
          DispatchMessageW(&msg);
        }
      }
    }
    if (msgstatus == -1)
    {
      API_LoadStringW(hLangLib, MSG_ERROR_IN_MESSAGE_QUEUE, wbuf, BUFFER_SIZE);
      MessageBoxW(NULL, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
    }
  }

  Quit:
  if (hRTFLib) FreeLibrary(hRTFLib);
  if (hLangLib && hLangLib != hInstance) FreeLibrary(hLangLib);
  ExitProcess(0);
}

LRESULT CALLBACK WndProcA(HWND hMainWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  LPARAM lMenuState;
  RECT rcRect;
  char *pFileName;
  int i;

  if (uMsg == uiOpenOnStartMessage)
  {
    cf.lStructSize   =sizeof(CHOOSEFONT);
    cf.hwndOwner     =hMainWnd;
    cf.hDC           =NULL;
    cf.lpLogFont     =&logfont;
    cf.iPointSize    =0;
    cf.rgbColors     =0;
    cf.lCustData     =0;
    cf.lpfnHook      =NULL;
    cf.lpTemplateName=NULL;
    cf.hInstance     =NULL;
    cf.lpszStyle     =NULL;
    cf.nFontType     =0;
    cf.nSizeMin      =0;
    cf.nSizeMax      =0;
    cf.Flags         =CF_FORCEFONTEXIST|CF_INITTOLOGFONTSTRUCT|CF_SCREENFONTS;

    cc.lStructSize   =sizeof(CHOOSECOLOR);
    cc.hwndOwner     =hMainWnd;
    cc.hInstance     =NULL;
    cc.lpCustColors  =crCustColors;
    cc.Flags         =CC_FULLOPEN|CC_RGBINIT;
    cc.lCustData     =0;
    cc.lpfnHook      =NULL;
    cc.lpTemplateName=NULL;

    psdPage.lStructSize=sizeof(PAGESETUPDLG);
    psdPage.hwndOwner  =hMainWnd;
    psdPage.Flags     |=PSD_MARGINS;

    pd.lStructSize=sizeof(PRINTDLG);
    pd.hwndOwner  =hMainWnd;
    pd.Flags      =PD_ALLPAGES|PD_NOPAGENUMS|PD_RETURNDC|PD_USEDEVMODECOPIESANDCOLLATE;
    pd.nCopies    =1;

    ofn.lStructSize      =sizeof(OPENFILENAME);
    ofn.hwndOwner        =hMainWnd;
    ofn.hInstance        =hLangLib;
    ofn.lpstrFile        =szFileBuffer;
    ofn.lpstrFilter      =szFilter;
    ofn.lpstrCustomFilter=NULL;
    ofn.nMaxCustFilter   =0;
    ofn.nFilterIndex     =2;
    ofn.nMaxFile         =FILELIST_BUFFER_SIZE;
    ofn.lpstrFileTitle   =NULL;
    ofn.nMaxFileTitle    =0;
    ofn.lpstrInitialDir  =NULL;
    ofn.lpstrTitle       =NULL;
    ofn.nFileOffset      =0;
    ofn.nFileExtension   =0;
    ofn.lCustData        =0;
    ofn.Flags            =OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_EXPLORER|OFN_ENABLEHOOK|OFN_ENABLETEMPLATE|OFN_ENABLESIZING;
    ofn.lpfnHook         =CodePageDlgProcA;
    ofn.lpTemplateName   =MAKEINTRESOURCE(IDD_OFN);

    psp[0].dwSize     =sizeof(PROPSHEETPAGE);
    psp[0].dwFlags    =PSP_DEFAULT;
    psp[0].hInstance  =hLangLib;
    psp[0].pszTemplate=MAKEINTRESOURCE(IDD_OPTIONS_GENERAL);
    psp[0].pfnDlgProc =(DLGPROC)OptionsGeneralDlgProcA;
    psp[1].dwSize     =sizeof(PROPSHEETPAGE);
    psp[1].dwFlags    =PSP_DEFAULT;
    psp[1].hInstance  =hLangLib;
    psp[1].pszTemplate=MAKEINTRESOURCE(IDD_OPTIONS_ADVANCED);
    psp[1].pfnDlgProc =(DLGPROC)OptionsAdvancedDlgProcA;

    psh.dwSize     =(bOldComctl32)?(PROPSHEETHEADER_V1_SIZE):(sizeof(PROPSHEETHEADER));
    psh.dwFlags    =PSH_PROPSHEETPAGE|PSH_NOAPPLYNOW|PSH_USEICONID|PSH_USECALLBACK;
    psh.hwndParent =hMainWnd;
    psh.hInstance  =hLangLib;
    psh.pszIcon    =MAKEINTRESOURCE(IDI_ICON_MAIN);
    psh.nPages     =sizeof(psp) / sizeof(PROPSHEETPAGE);
    psh.nStartPage =0;
    psh.ppsp       =&psp[0];
    psh.pfnCallback=PropSheetProc;

    //Create edit window
    if (!bMDI)
    {
      CreateEditWindowA(hMainWnd);
    }
    else
    {
      GetClientRect(hMdiClient, &rcRect);
      CreateMDIWindow(APP_MDI_CLASS, "", nMdiStyle, 0, 0, rcRect.right * 80 / 100, rcRect.bottom * 60 / 100, hMdiClient, hInstance, NULL);
    }

    //Allocate and read search string
    RegReadSearchA();

    //Allocate and read recent files
    if (nRecentFiles)
    {
      if ((szRecentNames=(char (*)[MAX_PATH])API_HeapAlloc(hHeap, 0, nRecentFiles * MAX_PATH)) &&
          (szRecentPositions=(DWORD *)API_HeapAlloc(hHeap, 0, nRecentFiles * sizeof(DWORD))) &&
          (szRecentCodepages=(DWORD *)API_HeapAlloc(hHeap, 0, nRecentFiles * sizeof(DWORD))))
      {
        RecentFilesZeroA();
        RecentFilesReadA();
      }
    }
    RecentFilesMenuA();

    //Register plugins hotkeys
    InitAtomTable(0);
    if (nSaveSettings == SS_REGISTRY)
      RegRegisterPluginsHotkeysA();
    else
      IniRegisterPluginsHotkeysA();

    //Apply settings
    szCurrentFile[0]='\0';
    SetFocus(hWndEdit);
    SetNewLineA(NEWLINE_WIN, TRUE);
    SetInsertStateA(FALSE, TRUE);
    SetModifyA(FALSE, TRUE);
    SetCodePageA(MAKELONG(nDefaultCodePage, bDefaultBOM), TRUE);
    DoViewOnTop(bOnTop, TRUE);
    DoViewShowStatusBar(bStatusBar, TRUE);
    DoSettingsSaveTime(bSaveTime);
    DoSettingsKeepSpace(bKeepSpace);
    DoSettingsWatchFileA(bWatchFile);
    DoSettingsSingleOpenFile(bSingleOpenFile);
    if (bMDI)
    {
      DoSettingsSingleOpenProgram(bSingleOpenProgram);
      DoWindowTabView(nTabView, TRUE);
      DoWindowTabType(nTabType, TRUE);
    }

    //Show main window
    ShowWindow(hMainWnd, (nMainStyle == WS_MAXIMIZE)?SW_SHOWMAXIMIZED:SW_SHOW);

    //Shortcut
    if (nCmdShow != SW_SHOWNORMAL)
      ShowWindow(hMainWnd, nCmdShow);

    if (*szFileBuffer) OpenDocumentA(szFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);

    if (hMutex)
    {
      ReleaseMutex(hMutex);
      CloseHandle(hMutex);
    }
  }

  if (uMsg == WM_CREATE)
  {
    int iSBParts[]={110, 220, 250, 280, -1};
    CLIENTCREATESTRUCT ccs;
    DWORD dwClassStyle;

    ShowWindow(hMainWnd, SW_HIDE);
    hPopupEdit=GetSubMenu(hPopupMenu, 0);
    hPopupView=GetSubMenu(hPopupMenu, 1);

    if (!bMDI)
    {
      DeleteMenu(hMainMenu, MDIMENU_POSITION, MF_BYPOSITION);
      DeleteMenu(hMainMenu, IDM_OPTIONS_SINGLEOPEN_PROGRAM, MF_BYCOMMAND);
      DragAcceptFiles(hMainWnd, TRUE);

      hDummyWindow=CreateWindow(APP_SDI_CLASS,         // window class name
                                APP_SDI_TITLE,         // window caption
                                WS_POPUP,              // window style
                                CW_USEDEFAULT,         // initial x position
                                CW_USEDEFAULT,         // initial y position
                                CW_USEDEFAULT,         // initial x size
                                CW_USEDEFAULT,         // initial y size
                                hMainWnd,              // parent window handle
                                NULL,                  // window menu handle
                                hInstance,             // program instance handle
                                NULL);                 // creation parameters
    }
    else
    {
      GetClientRect(hMainWnd, &rcRect);

      //MDI Client
      ccs.hWindowMenu=GetSubMenu(hMainMenu, MDIMENU_POSITION);
      ccs.idFirstChild=ID_FIRSTMDI;

      hMdiClient=CreateWindow("MdiClient",
                              NULL,
                              WS_CHILD|WS_VISIBLE|WS_CLIPCHILDREN|WS_VSCROLL|WS_HSCROLL,
                              0, 0, rcRect.right, rcRect.bottom,
                              hMainWnd,
                              NULL,
                              hInstance,
                              (LPVOID)&ccs);

      dwClassStyle=GetClassLong(hMdiClient, GCL_STYLE);
      SetClassLong(hMdiClient, GCL_STYLE, dwClassStyle|CS_DBLCLKS);

      OldMdiClientProc=(WNDPROC)GetWindowLong(hMdiClient, GWL_WNDPROC);
      SetWindowLong(hMdiClient, GWL_WNDPROC, (LONG)NewMdiClientProcA);

      DragAcceptFiles(hMdiClient, TRUE);

      //Tab Control
      hTab=CreateWindow("SysTabControl32",
                        NULL,
                        WS_CHILD|WS_VISIBLE|TCS_SINGLELINE|TCS_FOCUSNEVER,
                        0, 0, rcRect.right, TAB_HEIGHT,
                        hMainWnd,
                        (HMENU)ID_TAB,
                        hInstance,
                        0);

      OldTabProc=(WNDPROC)GetWindowLong(hTab, GWL_WNDPROC);
      SetWindowLong(hTab, GWL_WNDPROC, (LONG)NewTabProcA);

      tabfont.lfHeight        =8;
      tabfont.lfWidth         =0;
      tabfont.lfEscapement    =0;
      tabfont.lfOrientation   =0;
      tabfont.lfWeight        =FW_NORMAL;
      tabfont.lfItalic        =0;
      tabfont.lfUnderline     =0;
      tabfont.lfStrikeOut     =0;
      tabfont.lfCharSet       =ANSI_CHARSET;
      tabfont.lfOutPrecision  =OUT_DEFAULT_PRECIS;
      tabfont.lfClipPrecision =CLIP_DEFAULT_PRECIS;
      tabfont.lfQuality       =DEFAULT_QUALITY;
      tabfont.lfPitchAndFamily=DEFAULT_PITCH;
      lstrcpy(tabfont.lfFaceName, "MS Sans Serif");

      hTabFont=CreateFontIndirect(&tabfont);
      SendMessage(hTab, WM_SETFONT, (WPARAM)hTabFont, (LPARAM)TRUE);

      hImageList=ImageList_Create(GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), ILC_COLOR32|ILC_MASK, 0, 0);
      ImageList_SetBkColor(hImageList, GetSysColor(COLOR_ACTIVEBORDER)); //COLOR_BTNFACE
      SendMessage(hTab, TCM_SETIMAGELIST, 0, (LPARAM)hImageList);
      SendMessage(hTab, TCM_SETEXTENDEDSTYLE, 0, TCS_EX_FLATSEPARATORS);
    }

    //Status Bar
    hStatus=CreateWindow("msctls_statusbar32",
                         NULL,
                         WS_CHILD|WS_VISIBLE|SBARS_SIZEGRIP,
                         0, 0, 0, 0,
                         hMainWnd,
                         (HMENU)ID_STATUS,
                         hInstance,
                         NULL);

    SendMessage(hStatus, SB_SIMPLE, FALSE, 0);
    SendMessage(hStatus, SB_SETPARTS, 5, (LPARAM)&iSBParts);

    GetWindowRect(hStatus, &rcRect);
    nStatusHeight=rcRect.bottom - rcRect.top;

    PostMessage(hMainWnd, uiOpenOnStartMessage, 0, 0);
  }
  else if (uMsg == WM_INITMENU)
  {
    LanguageMenuA();
    lMenuState=SearchPath(NULL, "charmap.exe", NULL, BUFFER_SIZE, buf, &pFileName)?MF_ENABLED:MF_GRAYED;
    EnableMenuItem(hMainMenu, IDM_EDIT_INSERTCHAR, lMenuState);

    if (hWndEdit)
    {
      EnableMenuItem(hMainMenu, IDM_FILE_CREATENEW, (bMDI && bSingleOpenProgram)?MF_GRAYED:MF_ENABLED);
      EnableMenuItem(hMainMenu, IDM_FILE_REOPEN, (*szCurrentFile)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMainMenu, IDM_FILE_SAVE, (bModified || !*szCurrentFile)?MF_ENABLED:MF_GRAYED);

      lMenuState=(chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED;
      EnableMenuItem(hMainMenu, IDM_EDIT_CUT, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_COPY, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_CLEAR, lMenuState);

      lMenuState=(!DoEditInsertStringInSelectionA(hWndEdit, STRSEL_CHECK, NULL))?MF_GRAYED:MF_ENABLED;
      EnableMenuItem(hMainMenu, IDM_EDIT_INSERT_TAB_MENU, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_DELETE_TAB_MENU, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_INSERT_SPACE_MENU, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_DELETE_SPACE_MENU, lMenuState);

      EnableMenuItem(hMainMenu, IDM_EDIT_UNDO, SendMessage(hWndEdit, EM_CANUNDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMainMenu, IDM_EDIT_REDO, SendMessage(hWndEdit, EM_CANREDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMainMenu, IDM_EDIT_PASTE, SendMessage(hWndEdit, EM_CANPASTE, 0, 0)?MF_ENABLED:MF_GRAYED);

      EnableMenuItem(hMainMenu, IDM_OPTIONS_EXEC, (*szCommand)?MF_ENABLED:MF_GRAYED);

      if (bOldComctl32) EnableMenuItem(hMainMenu, IDM_WINDOW_TABTYPE_FLATBUTTONS, MF_GRAYED);
    }
  }
  else if (uMsg == WM_MENUSELECT ||
           uMsg == WM_INITMENUPOPUP)
  {
    CheckMenuItem(hMainMenu, IDM_OPTIONS_SDI, bRegMDI?MF_UNCHECKED:MF_CHECKED);
    CheckMenuItem(hMainMenu, IDM_OPTIONS_MDI, bRegMDI?MF_CHECKED:MF_UNCHECKED);

    if (hWndEdit)
    {
      CheckMenuItem(hMainMenu, IDM_EDIT_NEWLINE_WIN, (nNewLine == NEWLINE_WIN)?MF_CHECKED:MF_UNCHECKED);
      CheckMenuItem(hMainMenu, IDM_EDIT_NEWLINE_UNIX, (nNewLine == NEWLINE_UNIX)?MF_CHECKED:MF_UNCHECKED);
    }
  }
  else if (uMsg == WM_MOVE)
  {
    i=GetWindowLong(hMainWnd, GWL_STYLE);

    if (!(i & WS_MAXIMIZE) && !(i & WS_MINIMIZE))
    {
      GetWindowRect(hMainWnd, &rcMainWindow);
      rcMainWindow.right-=rcMainWindow.left;
      rcMainWindow.bottom-=rcMainWindow.top;
    }
  }
  else if (uMsg == WM_SIZE)
  {
    if (wParam != SIZE_MAXIMIZED && wParam != SIZE_MINIMIZED)
    {
      GetWindowRect(hMainWnd, &rcMainWindow);
      rcMainWindow.right-=rcMainWindow.left;
      rcMainWindow.bottom-=rcMainWindow.top;
    }
    if (wParam != SIZE_MINIMIZED) nLastMainSize=wParam;

    SendMessage(hStatus, WM_SIZE, wParam, lParam);
    UpdateSize(LOWORD(lParam), HIWORD(lParam));
    return TRUE;
  }
  else if (uMsg == WM_DROPFILES)
  {
    if (SaveChangedA())
    {
      nPosition=nPositionOld;
      DragQueryFile((HDROP)wParam, 0, szFileBuffer, FILELIST_BUFFER_SIZE);
      OpenDocumentA(szFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
      DragFinish((HDROP)wParam);
    }
  }
  else if (uMsg == WM_HOTKEY)
  {
    GetAtomName(wParam, buf, BUFFER_SIZE);
    CallPluginA(buf);
  }
  else if (uMsg == WM_LBUTTONDBLCLK)
  {
    if (bMDI)
    {
      if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
      CreateMDIWindow(APP_MDI_CLASS, "", (bMdiMaximize == TRUE)?WS_MAXIMIZE:0, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hMdiClient, hInstance, 0);
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDM_RECENT_FILES)
    {
      int nDead;

      RecentFilesReadA();
      nDead=RecentFilesDeleteDeadA();
      RecentFilesSaveA();
      RecentFilesMenuA();

      API_LoadStringA(hLangLib, MSG_RECENTFILES_DELETED, buf, BUFFER_SIZE);
      wsprintf(buf2, buf, nDead);
      MessageBox(hMainWnd, buf2, APP_MAIN_TITLE, MB_OK|MB_ICONINFORMATION);
      return TRUE;
    }
    if (LOWORD(wParam) > IDM_RECENT_FILES && LOWORD(wParam) <= IDM_RECENT_FILES + nRecentFiles)
    {
      if (SaveChangedA())
      {
        lstrcpy(szFileBuffer, szRecentNames[LOWORD(wParam) - IDM_RECENT_FILES - 1]);
        OpenDocumentA(szFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
      }
      return TRUE;
    }
    if (LOWORD(wParam) >= IDM_LANGUAGE && LOWORD(wParam) <= IDM_LANGUAGE+nLangModules+1)
    {
      if (LOWORD(wParam) == IDM_LANGUAGE)
      {
        if (!*szLangModule) return TRUE;
        szLangModule[0]='\0';
      }
      else
      {
        GetMenuString(hMainMenu, LOWORD(wParam), buf, BUFFER_SIZE, MF_BYCOMMAND);
        wsprintf(buf2, "%s.dll", buf);
        if (!lstrcmpi(szLangModule, buf2)) return TRUE;
        lstrcpy(szLangModule, buf2);
      }
      API_LoadStringA(hLangLib, MSG_RESTART_PROGRAM, buf, BUFFER_SIZE);
      MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OK|MB_ICONEXCLAMATION);
      return TRUE;
    }

    if (LOWORD(wParam) == IDM_FILE_NEW)
    {
      DoFileNewA();
    }
    else if (LOWORD(wParam) == IDM_FILE_CREATENEW)
    {
      if (!bMDI)
      {
        if (nSaveSettings == SS_REGISTRY)
          RegSaveOptionsA();
        else
          IniSaveOptionsA();
      }
      DoFileNewWindowA(0);
    }
    else if (LOWORD(wParam) == IDM_FILE_OPEN)
    {
      DoFileOpenA();
    }
    else if (LOWORD(wParam) == IDM_FILE_REOPEN)
    {
      DoFileReopenAsA(0, nCurrentCodePage, bCurrentBOM);
    }
    else if (LOWORD(wParam) == IDM_FILE_SAVE)
    {
      DoFileSaveA();
    }
    else if (LOWORD(wParam) == IDM_FILE_SAVEAS)
    {
      DoFileSaveAsA();
    }
    else if (LOWORD(wParam) == IDM_FILE_PAGESETUP)
    {
      DoFilePageSetupA();
    }
    else if (LOWORD(wParam) == IDM_FILE_PRINT)
    {
      DoFilePrintA();
    }
    else if (LOWORD(wParam) == IDM_FILE_EXIT)
    {
      PostMessage(hMainWnd, WM_CLOSE, 0, 0);
    }
    else if (LOWORD(wParam) == IDM_EDIT_UNDO)
    {
      DoEditUndo(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_REDO)
    {
      DoEditRedo(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_CUT)
    {
      DoEditCut(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_COPY)
    {
      DoEditCopy(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_PASTE)
    {
      DoEditPaste(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_PASTEANSI)
    {
      DoEditPasteANSI(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_CLEAR)
    {
      DoEditClear(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_SELECTALL)
    {
      DoEditSelectAll(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_INSERTCHAR)
    {
      DoEditInsertChar();
    }
    else if (LOWORD(wParam) == IDM_EDIT_RECODE)
    {
      DoEditRecodeA(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_INSERT_TAB_MENU ||
             LOWORD(wParam) == IDM_EDIT_INSERT_TAB)
    {
      if (!DoEditInsertStringInSelectionA(hWndEdit, STRSEL_CHECK, NULL))
        InsertTabStopA(hWndEdit);
      else
        IndentTabStopA(hWndEdit, STRSEL_INSERT);
    }
    else if (LOWORD(wParam) == IDM_EDIT_DELETE_TAB_MENU ||
             LOWORD(wParam) == IDM_EDIT_DELETE_TAB)
    {
      if (!DoEditInsertStringInSelectionA(hWndEdit, STRSEL_CHECK, NULL))
        InsertTabStopA(hWndEdit);
      else
        IndentTabStopA(hWndEdit, STRSEL_DELETE|STRSEL_TAB);
    }
    else if (LOWORD(wParam) == IDM_EDIT_INSERT_SPACE_MENU ||
             LOWORD(wParam) == IDM_EDIT_INSERT_SPACE)
    {
      if (!DoEditInsertStringInSelectionA(hWndEdit, STRSEL_CHECK, NULL))
        SendMessage(hWndEdit, WM_CHAR, (WPARAM)' ', 0);
      else
        DoEditInsertStringInSelectionA(hWndEdit, STRSEL_INSERT, " ");
    }
    else if (LOWORD(wParam) == IDM_EDIT_DELETE_SPACE_MENU ||
             LOWORD(wParam) == IDM_EDIT_DELETE_SPACE)
    {
      if (!DoEditInsertStringInSelectionA(hWndEdit, STRSEL_CHECK, NULL))
        SendMessage(hWndEdit, WM_CHAR, (WPARAM)' ', 0);
      else
        DoEditInsertStringInSelectionA(hWndEdit, STRSEL_DELETE|STRSEL_SPACE, " ");
    }
    else if (LOWORD(wParam) == IDM_EDIT_DELETE_TRAILING_WHITESPACES)
    {
      DoEditDeleteTrailingWhitespacesA(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_UPPERCASE)
    {
      DoEditChangeCaseA(hWndEdit, UPPERCASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_LOWERCASE)
    {
      DoEditChangeCaseA(hWndEdit, LOWERCASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_SENTENCECASE)
    {
      DoEditChangeCaseA(hWndEdit, SENTENCECASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_TITLECASE)
    {
      DoEditChangeCaseA(hWndEdit, TITLECASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_INVERTCASE)
    {
      DoEditChangeCaseA(hWndEdit, INVERTCASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_NEWLINE_WIN)
    {
      SetNewLineA(NEWLINE_WIN, FALSE);
      SetModifyA(TRUE, FALSE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_NEWLINE_UNIX)
    {
      SetNewLineA(NEWLINE_UNIX, FALSE);
      SetModifyA(TRUE, FALSE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_FIND)
    {
      DoEditFindA();
    }
    else if (LOWORD(wParam) == IDM_EDIT_FINDNEXTDOWN)
    {
      DoEditFindNextDownA(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_FINDNEXTUP)
    {
      DoEditFindNextUpA(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_REPLACE)
    {
      DoEditReplaceA();
    }
    else if (LOWORD(wParam) == IDM_EDIT_GOTOLINE)
    {
      DoEditGoToLineA();
    }
    else if (LOWORD(wParam) == IDM_VIEW_FONT)
    {
      DoViewFontA(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_VIEW_TEXT_COLOR)
    {
      DoViewTextColorA(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_VIEW_BG_COLOR)
    {
      DoViewBGColorA(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_VIEW_INCREASE_FONT)
    {
      DoViewFontSizeA(hWndEdit, INCREASE_FONT);
    }
    else if (LOWORD(wParam) == IDM_VIEW_DECREASE_FONT)
    {
      DoViewFontSizeA(hWndEdit, DECREASE_FONT);
    }
    else if (LOWORD(wParam) == IDM_VIEW_ALIGN_CENTER)
    {
      DoViewAlignment(hWndEdit, PFA_CENTER);
    }
    else if (LOWORD(wParam) == IDM_VIEW_ALIGN_RIGHT)
    {
      DoViewAlignment(hWndEdit, PFA_RIGHT);
    }
    else if (LOWORD(wParam) == IDM_VIEW_ALIGN_LEFT)
    {
      DoViewAlignment(hWndEdit, PFA_LEFT);
    }
    else if (LOWORD(wParam) == IDM_VIEW_WORDWRAP)
    {
      DoViewWordWrap(hWndEdit, !bWordWrap, FALSE);
    }
    else if (LOWORD(wParam) == IDM_VIEW_ONTOP)
    {
      DoViewOnTop(!bOnTop, FALSE);
    }
    else if (LOWORD(wParam) == IDM_VIEW_SHOW_STATUSBAR)
    {
      DoViewShowStatusBar(!bStatusBar, FALSE);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_EXEC)
    {
      DoSettingsExecA();
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_SAVETIME)
    {
      DoSettingsSaveTime(!bSaveTime);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_KEEPSPACE)
    {
      DoSettingsKeepSpace(!bKeepSpace);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_WATCHFILE)
    {
      DoSettingsWatchFileA(!bWatchFile);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_SINGLEOPEN_FILE)
    {
      DoSettingsSingleOpenFile(!bSingleOpenFile);
      if (nSaveSettings == SS_REGISTRY)
        RegSaveOptionsA();
      else
        IniSaveOptionsA();
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_SINGLEOPEN_PROGRAM)
    {
      DoSettingsSingleOpenProgram(!bSingleOpenProgram);
      if (nSaveSettings == SS_REGISTRY)
        RegSaveOptionsA();
      else
        IniSaveOptionsA();
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_SDI)
    {
      if (bRegMDI)
      {
        API_LoadStringA(hLangLib, MSG_RESTART_PROGRAM, buf, BUFFER_SIZE);
        MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OK|MB_ICONEXCLAMATION);
        bRegMDI=FALSE;
      }
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_MDI)
    {
      if (!bRegMDI)
      {
        API_LoadStringA(hLangLib, MSG_RESTART_PROGRAM, buf, BUFFER_SIZE);
        MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OK|MB_ICONEXCLAMATION);
        bRegMDI=TRUE;
      }
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_PLUGINS)
    {
      DoSettingsPluginsA(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS)
    {
      DoSettingsOptionsA();
    }
    else if (LOWORD(wParam) == IDM_ABOUT)
    {
      DoHelpAboutA();
    }
    else if (LOWORD(wParam) == IDM_NONMENU_CHANGESIZE)
    {
      ShowWindow(hMainWnd, (GetWindowLong(hMainWnd, GWL_STYLE) & WS_MAXIMIZE)?SW_RESTORE:SW_MAXIMIZE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_DELLINE)
    {
      DoNonMenuDelLine(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPENAS_ANSI)
    {
      DoFileReopenAsA(0, nAnsiCodePage, FALSE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPENAS_OEM)
    {
      DoFileReopenAsA(0, nOemCodePage, FALSE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPENAS_UTF8)
    {
      DoFileReopenAsA(ADT_DETECT_BOM, CP_UNICODE_UTF8, FALSE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPENAS_KOIR)
    {
      DoFileReopenAsA(0, CP_KOI8_R, FALSE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPEN_MSG)
    {
      API_LoadStringA(hLangLib, MSG_FILE_CHANGED, buf, BUFFER_SIZE);
      wsprintf(buf2, buf, szCurrentFile);
      if (MessageBox(hMainWnd, buf2, APP_MAIN_TITLE, bModified?MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2:MB_YESNO|MB_ICONQUESTION) == IDYES)
      {
        bMdiReopen=TRUE;
        OpenDocumentA(szCurrentFile, 0, nCurrentCodePage, bCurrentBOM);
        bMdiReopen=FALSE;
      }
    }
    else if (LOWORD(wParam) == IDM_NONMENU_SETFILEPRINT)
    {
      bGlobalPrint=TRUE;
    }
    else if (LOWORD(wParam) == IDM_NONMENU_SETMSGCREATE)
    {
      nMsgCreate=(int)lParam;
    }
    else if (LOWORD(wParam) == IDM_NONMENU_SETMSGBINARY)
    {
      nMsgBinary=(int)lParam;
    }
    else if (LOWORD(wParam) == IDM_NONMENU_FILEOPEN)
    {
      if (bMDI || SaveChangedA())
      {
        GlobalGetAtomName(HIWORD(wParam), szFileBuffer, FILELIST_BUFFER_SIZE);
        OpenDocumentA(szFileBuffer, LOWORD(lParam), HIWORD(lParam), FALSE);
      }
    }

    if (bMDI)
    {
      if (LOWORD(wParam) == IDM_WINDOW_TABVIEW_TOP)
      {
        DoWindowTabView(TAB_VIEW_TOP, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABVIEW_BOTTOM)
      {
        DoWindowTabView(TAB_VIEW_BOTTOM, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABVIEW_NONE)
      {
        DoWindowTabView(TAB_VIEW_NONE, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABTYPE_STANDART)
      {
        DoWindowTabType(TAB_TYPE_STANDART, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABTYPE_BUTTONS)
      {
        DoWindowTabType(TAB_TYPE_BUTTONS, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABTYPE_FLATBUTTONS)
      {
        DoWindowTabType(TAB_TYPE_FLATBUTTONS, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TILEHORIZONTAL)
      {
        PostMessage(hMdiClient, WM_MDITILE, MDITILE_HORIZONTAL, 0);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TILEVERTICAL)
      {
        PostMessage(hMdiClient, WM_MDITILE, MDITILE_VERTICAL, 0);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_CASCADE)
      {
        PostMessage(hMdiClient, WM_MDICASCADE, 0, 0);
      }
      else if (LOWORD(wParam) == IDM_NONMENU_MDINEXT)
      {
        PostMessage(hMdiClient, WM_MDINEXT, (WPARAM)hWndMdiActive, FALSE);
      }
      else if (LOWORD(wParam) == IDM_NONMENU_MDIPREV)
      {
        PostMessage(hMdiClient, WM_MDINEXT, (WPARAM)hWndMdiActive, TRUE);
      }
      else if (LOWORD(wParam) == IDM_NONMENU_MDICLOSE)
      {
        PostMessage(hMdiClient, WM_MDIDESTROY, (WPARAM)hWndMdiActive, 0);
      }
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (wParam == ID_STATUS && (!bMDI || hWndMdiActive))
    {
      if (((NMHDR *)lParam)->code == NM_DBLCLK)
      {
        if (((LPNMMOUSE)lParam)->dwItemSpec == 0)
        {
          DoEditGoToLineA();
        }
        else if (((LPNMMOUSE)lParam)->dwItemSpec == 2)
        {
          SendMessage(hWndEdit, WM_KEYDOWN, VK_INSERT, 0x00520001);
          SendMessage(hWndEdit, WM_KEYUP, VK_INSERT, 0xC0520001);
        }
        else if (((LPNMMOUSE)lParam)->dwItemSpec == 3)
        {
          if (nNewLine == NEWLINE_WIN) SetNewLineA(NEWLINE_UNIX, FALSE);
          else if (nNewLine == NEWLINE_UNIX) SetNewLineA(NEWLINE_WIN, FALSE);
          SetModifyA(TRUE, FALSE);
        }
      }
    }

    if (bMDI)
    {
      if (wParam == ID_TAB)
      {
        if (((NMHDR *)lParam)->code == TCN_SELCHANGE)
        {
          TCITEMW tcItem;

          bTabPressed=TRUE;
          i=SendMessage(hTab, TCM_GETCURSEL, 0, 0);
          tcItem.mask=TCIF_PARAM;
          SendMessage(hTab, TCM_GETITEM, (WPARAM)i, (LPARAM)&tcItem);
          SendMessage(hMdiClient, WM_MDIACTIVATE, (WPARAM)tcItem.lParam, 0);
        }
      }
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    if (!bMDI)
    {
      if (!DoFileExitA()) return TRUE;
      DestroyWindow(hWndEdit);
    }
    else
    {
      while (hWndMdiActive)
      {
        SendMessage(hMdiClient, WM_MDIDESTROY, (WPARAM)hWndMdiActive, 0);
        if (!bFileExitError) return TRUE;
      }
    }
    DestroyWindow(hMainWnd);
  }
  else if (uMsg == WM_DESTROY)
  {
    //Save options
    if (nSaveSettings == SS_REGISTRY)
      RegSaveOptionsA();
    else
      IniSaveOptionsA();

    //Clean up
    if (bMDI)
    {
      DeleteObject(hTabFont);
      ImageList_Destroy(hImageList);
    }
    DestroyAcceleratorTable(hMainAccel);
    DestroyIcon(hMainIcon);
    DestroyIcon(hIconEmpty);
    DestroyMenu(hMainMenu);
    DestroyMenu(hPopupMenu);
    FreeMemoryRecentFilesA();
    FreeMemorySearchA();

    PostQuitMessage(0);
  }

  if (!bMDI)
  {
    if (MdiProcA(hMainWnd, uMsg, wParam, lParam) == TRUE) return TRUE;

    return DefWindowProc(hMainWnd, uMsg, wParam, lParam);
  }
  else
  {
    return DefFrameProc(hMainWnd, hMdiClient, uMsg, wParam, lParam);
  }
}

LRESULT CALLBACK WndProcW(HWND hMainWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  LPARAM lMenuState;
  RECT rcRect;
  wchar_t *wpFileName;
  int i;

  if (uMsg == uiOpenOnStartMessage)
  {
    cfW.lStructSize   =sizeof(CHOOSEFONTW);
    cfW.hwndOwner     =hMainWnd;
    cfW.hDC           =NULL;
    cfW.lpLogFont     =&logfontW;
    cfW.iPointSize    =0;
    cfW.rgbColors     =0;
    cfW.lCustData     =0;
    cfW.lpfnHook      =NULL;
    cfW.lpTemplateName=NULL;
    cfW.hInstance     =NULL;
    cfW.lpszStyle     =NULL;
    cfW.nFontType     =0;
    cfW.nSizeMin      =0;
    cfW.nSizeMax      =0;
    cfW.Flags         =CF_FORCEFONTEXIST|CF_INITTOLOGFONTSTRUCT|CF_SCREENFONTS;

    ccW.lStructSize   =sizeof(CHOOSECOLORW);
    ccW.hwndOwner     =hMainWnd;
    ccW.hInstance     =NULL;
    ccW.lpCustColors  =crCustColors;
    ccW.Flags         =CC_FULLOPEN|CC_RGBINIT;
    ccW.lCustData     =0;
    ccW.lpfnHook      =NULL;
    ccW.lpTemplateName=NULL;

    psdPageW.lStructSize=sizeof(PAGESETUPDLGW);
    psdPageW.hwndOwner  =hMainWnd;
    psdPageW.Flags     |=PSD_MARGINS;

    pdW.lStructSize=sizeof(PRINTDLGW);
    pdW.hwndOwner  =hMainWnd;
    pdW.Flags      =PD_ALLPAGES|PD_NOPAGENUMS|PD_RETURNDC|PD_USEDEVMODECOPIESANDCOLLATE;
    pdW.nCopies    =1;

    ofnW.lStructSize      =sizeof(OPENFILENAMEW);
    ofnW.hwndOwner        =hMainWnd;
    ofnW.hInstance        =hLangLib;
    ofnW.lpstrFile        =wszFileBuffer;
    ofnW.lpstrFilter      =wszFilter;
    ofnW.lpstrCustomFilter=NULL;
    ofnW.nMaxCustFilter   =0;
    ofnW.nFilterIndex     =2;
    ofnW.nMaxFile         =FILELIST_BUFFER_SIZE;
    ofnW.lpstrFileTitle   =NULL;
    ofnW.nMaxFileTitle    =0;
    ofnW.lpstrInitialDir  =NULL;
    ofnW.lpstrTitle       =NULL;
    ofnW.nFileOffset      =0;
    ofnW.nFileExtension   =0;
    ofnW.lCustData        =0;
    ofnW.Flags            =OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_EXPLORER|OFN_ENABLEHOOK|OFN_ENABLETEMPLATE|OFN_ENABLESIZING;
    ofnW.lpfnHook         =CodePageDlgProcW;
    ofnW.lpTemplateName   =MAKEINTRESOURCEW(IDD_OFN);

    pspW[0].dwSize     =sizeof(PROPSHEETPAGEW);
    pspW[0].dwFlags    =PSP_DEFAULT;
    pspW[0].hInstance  =hLangLib;
    pspW[0].pszTemplate=MAKEINTRESOURCEW(IDD_OPTIONS_GENERAL);
    pspW[0].pfnDlgProc =(DLGPROC)OptionsGeneralDlgProcW;
    pspW[1].dwSize     =sizeof(PROPSHEETPAGEW);
    pspW[1].dwFlags    =PSP_DEFAULT;
    pspW[1].hInstance  =hLangLib;
    pspW[1].pszTemplate=MAKEINTRESOURCEW(IDD_OPTIONS_ADVANCED);
    pspW[1].pfnDlgProc =(DLGPROC)OptionsAdvancedDlgProcW;

    pshW.dwSize     =sizeof(PROPSHEETHEADERW);
    pshW.dwFlags    =PSH_PROPSHEETPAGE|PSH_NOAPPLYNOW|PSH_USEICONID|PSH_USECALLBACK;
    pshW.hwndParent =hMainWnd;
    pshW.hInstance  =hLangLib;
    pshW.pszIcon    =MAKEINTRESOURCEW(IDI_ICON_MAIN);
    pshW.nPages     =sizeof(pspW) / sizeof(PROPSHEETPAGEW);
    pshW.nStartPage =0;
    pshW.ppsp       =&pspW[0];
    pshW.pfnCallback=PropSheetProc;

    //Create edit window
    if (!bMDI)
    {
      CreateEditWindowW(hMainWnd);
    }
    else
    {
      GetClientRect(hMdiClient, &rcRect);
      CreateMDIWindowW(APP_MDI_CLASSW, L"", nMdiStyle, 0, 0, rcRect.right * 80 / 100, rcRect.bottom * 60 / 100, hMdiClient, hInstance, NULL);
    }

    //Allocate and read search string
    RegReadSearchW();

    //Allocate and read recent files
    if (nRecentFiles)
    {
      if ((wszRecentNames=(wchar_t (*)[MAX_PATH])API_HeapAlloc(hHeap, 0, nRecentFiles * MAX_PATH * sizeof(wchar_t))) &&
          (szRecentPositions=(DWORD *)API_HeapAlloc(hHeap, 0, nRecentFiles * sizeof(DWORD))) &&
          (szRecentCodepages=(DWORD *)API_HeapAlloc(hHeap, 0, nRecentFiles * sizeof(DWORD))))
      {
        RecentFilesZeroW();
        RecentFilesReadW();
      }
    }
    RecentFilesMenuW();

    //Register plugins hotkeys
    InitAtomTable(0);
    if (nSaveSettings == SS_REGISTRY)
      RegRegisterPluginsHotkeysW();
    else
      IniRegisterPluginsHotkeysW();

    //Apply settings
    wszCurrentFile[0]='\0';
    SetFocus(hWndEdit);
    SetNewLineW(NEWLINE_WIN, TRUE);
    SetInsertStateW(FALSE, TRUE);
    SetModifyW(FALSE, TRUE);
    SetCodePageW(MAKELONG(nDefaultCodePage, bDefaultBOM), TRUE);
    DoViewOnTop(bOnTop, TRUE);
    DoViewShowStatusBar(bStatusBar, TRUE);
    DoSettingsSaveTime(bSaveTime);
    DoSettingsKeepSpace(bKeepSpace);
    DoSettingsWatchFileW(bWatchFile);
    DoSettingsSingleOpenFile(bSingleOpenFile);
    if (bMDI)
    {
      DoSettingsSingleOpenProgram(bSingleOpenProgram);
      DoWindowTabView(nTabView, TRUE);
      DoWindowTabType(nTabType, TRUE);
    }

    //Show main window
    ShowWindow(hMainWnd, (nMainStyle == WS_MAXIMIZE)?SW_SHOWMAXIMIZED:SW_SHOW);

    //Shortcut
    if (nCmdShow != SW_SHOWNORMAL)
      ShowWindow(hMainWnd, nCmdShow);

    if (*wszFileBuffer) OpenDocumentW(wszFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);

    if (hMutex)
    {
      ReleaseMutex(hMutex);
      CloseHandle(hMutex);
    }
  }

  if (uMsg == WM_CREATE)
  {
    int iSBParts[]={110, 220, 250, 280, -1};
    CLIENTCREATESTRUCT ccs;
    DWORD dwClassStyle;

    ShowWindow(hMainWnd, SW_HIDE);
    hPopupEdit=GetSubMenu(hPopupMenu, 0);
    hPopupView=GetSubMenu(hPopupMenu, 1);

    if (!bMDI)
    {
      DeleteMenu(hMainMenu, MDIMENU_POSITION, MF_BYPOSITION);
      DeleteMenu(hMainMenu, IDM_OPTIONS_SINGLEOPEN_PROGRAM, MF_BYCOMMAND);
      DragAcceptFiles(hMainWnd, TRUE);

      hDummyWindow=CreateWindowW(APP_SDI_CLASSW,        // window class name
                                 APP_SDI_TITLEW,        // window caption
                                 WS_POPUP,              // window style
                                 CW_USEDEFAULT,         // initial x position
                                 CW_USEDEFAULT,         // initial y position
                                 CW_USEDEFAULT,         // initial x size
                                 CW_USEDEFAULT,         // initial y size
                                 hMainWnd,              // parent window handle
                                 NULL,                  // window menu handle
                                 hInstance,             // program instance handle
                                 NULL);                 // creation parameters
    }
    else
    {
      GetClientRect(hMainWnd, &rcRect);

      //MDI Client
      ccs.hWindowMenu=GetSubMenu(hMainMenu, MDIMENU_POSITION);
      ccs.idFirstChild=ID_FIRSTMDI;

      hMdiClient=CreateWindowW(L"MdiClient",
                               NULL,
                               WS_CHILD|WS_VISIBLE|WS_CLIPCHILDREN|WS_VSCROLL|WS_HSCROLL,
                               0, 0, rcRect.right, rcRect.bottom,
                               hMainWnd,
                               NULL,
                               hInstance,
                               (LPVOID)&ccs);

      dwClassStyle=GetClassLongW(hMdiClient, GCL_STYLE);
      SetClassLongW(hMdiClient, GCL_STYLE, dwClassStyle|CS_DBLCLKS);

      OldMdiClientProc=(WNDPROC)GetWindowLongW(hMdiClient, GWL_WNDPROC);
      SetWindowLongW(hMdiClient, GWL_WNDPROC, (LONG)NewMdiClientProcW);

      DragAcceptFiles(hMdiClient, TRUE);

      //Tab Control
      hTab=CreateWindowW(L"SysTabControl32",
                         NULL,
                         WS_CHILD|WS_VISIBLE|TCS_SINGLELINE|TCS_FOCUSNEVER,
                         0, 0, rcRect.right, TAB_HEIGHT,
                         hMainWnd,
                         (HMENU)ID_TAB,
                         hInstance,
                         0);

      OldTabProc=(WNDPROC)GetWindowLongW(hTab, GWL_WNDPROC);
      SetWindowLongW(hTab, GWL_WNDPROC, (LONG)NewTabProcW);

      tabfontW.lfHeight        =8;
      tabfontW.lfWidth         =0;
      tabfontW.lfEscapement    =0;
      tabfontW.lfOrientation   =0;
      tabfontW.lfWeight        =FW_NORMAL;
      tabfontW.lfItalic        =0;
      tabfontW.lfUnderline     =0;
      tabfontW.lfStrikeOut     =0;
      tabfontW.lfCharSet       =ANSI_CHARSET;
      tabfontW.lfOutPrecision  =OUT_DEFAULT_PRECIS;
      tabfontW.lfClipPrecision =CLIP_DEFAULT_PRECIS;
      tabfontW.lfQuality       =DEFAULT_QUALITY;
      tabfontW.lfPitchAndFamily=DEFAULT_PITCH;
      lstrcpyW(tabfontW.lfFaceName, L"MS Sans Serif");

      hTabFont=CreateFontIndirectW(&tabfontW);
      SendMessage(hTab, WM_SETFONT, (WPARAM)hTabFont, (LPARAM)TRUE);

      hImageList=ImageList_Create(GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), ILC_COLOR32|ILC_MASK, 0, 0);
      ImageList_SetBkColor(hImageList, GetSysColor(COLOR_ACTIVEBORDER)); //COLOR_BTNFACE
      SendMessage(hTab, TCM_SETIMAGELIST, 0, (LPARAM)hImageList);
      SendMessage(hTab, TCM_SETEXTENDEDSTYLE, 0, TCS_EX_FLATSEPARATORS);
    }

    //Status Bar
    hStatus=CreateWindowW(L"msctls_statusbar32",
                          NULL,
                          WS_CHILD|WS_VISIBLE|SBARS_SIZEGRIP,
                          0, 0, 0, 0,
                          hMainWnd,
                          (HMENU)ID_STATUS,
                          hInstance,
                          NULL);

    SendMessage(hStatus, SB_SIMPLE, FALSE, 0);
    SendMessage(hStatus, SB_SETPARTS, 5, (LPARAM)&iSBParts);

    GetWindowRect(hStatus, &rcRect);
    nStatusHeight=rcRect.bottom - rcRect.top;

    PostMessage(hMainWnd, uiOpenOnStartMessage, 0, 0);
  }
  else if (uMsg == WM_INITMENU)
  {
    LanguageMenuW();
    lMenuState=SearchPathW(NULL, L"charmap.exe", NULL, BUFFER_SIZE, wbuf, &wpFileName)?MF_ENABLED:MF_GRAYED;
    EnableMenuItem(hMainMenu, IDM_EDIT_INSERTCHAR, lMenuState);

    if (hWndEdit)
    {
      EnableMenuItem(hMainMenu, IDM_FILE_CREATENEW, (bMDI && bSingleOpenProgram)?MF_GRAYED:MF_ENABLED);
      EnableMenuItem(hMainMenu, IDM_FILE_REOPEN, (*wszCurrentFile)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMainMenu, IDM_FILE_SAVE, (bModified || !*wszCurrentFile)?MF_ENABLED:MF_GRAYED);

      lMenuState=(chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED;
      EnableMenuItem(hMainMenu, IDM_EDIT_CUT, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_COPY, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_CLEAR, lMenuState);

      lMenuState=(!DoEditInsertStringInSelectionW(hWndEdit, STRSEL_CHECK, NULL))?MF_GRAYED:MF_ENABLED;
      EnableMenuItem(hMainMenu, IDM_EDIT_INSERT_TAB_MENU, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_DELETE_TAB_MENU, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_INSERT_SPACE_MENU, lMenuState);
      EnableMenuItem(hMainMenu, IDM_EDIT_DELETE_SPACE_MENU, lMenuState);

      EnableMenuItem(hMainMenu, IDM_EDIT_UNDO, SendMessage(hWndEdit, EM_CANUNDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMainMenu, IDM_EDIT_REDO, SendMessage(hWndEdit, EM_CANREDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMainMenu, IDM_EDIT_PASTE, SendMessage(hWndEdit, EM_CANPASTE, 0, 0)?MF_ENABLED:MF_GRAYED);

      EnableMenuItem(hMainMenu, IDM_OPTIONS_EXEC, (*wszCommand)?MF_ENABLED:MF_GRAYED);

      if (bOldComctl32) EnableMenuItem(hMainMenu, IDM_WINDOW_TABTYPE_FLATBUTTONS, MF_GRAYED);
    }
  }
  else if (uMsg == WM_MENUSELECT ||
           uMsg == WM_INITMENUPOPUP)
  {
    CheckMenuItem(hMainMenu, IDM_OPTIONS_SDI, bRegMDI?MF_UNCHECKED:MF_CHECKED);
    CheckMenuItem(hMainMenu, IDM_OPTIONS_MDI, bRegMDI?MF_CHECKED:MF_UNCHECKED);

    if (hWndEdit)
    {
      CheckMenuItem(hMainMenu, IDM_EDIT_NEWLINE_WIN, (nNewLine == NEWLINE_WIN)?MF_CHECKED:MF_UNCHECKED);
      CheckMenuItem(hMainMenu, IDM_EDIT_NEWLINE_UNIX, (nNewLine == NEWLINE_UNIX)?MF_CHECKED:MF_UNCHECKED);
    }
  }
  else if (uMsg == WM_MOVE)
  {
    i=GetWindowLong(hMainWnd, GWL_STYLE);

    if (!(i & WS_MAXIMIZE) && !(i & WS_MINIMIZE))
    {
      GetWindowRect(hMainWnd, &rcMainWindow);
      rcMainWindow.right-=rcMainWindow.left;
      rcMainWindow.bottom-=rcMainWindow.top;
    }
  }
  else if (uMsg == WM_SIZE)
  {
    if (wParam != SIZE_MAXIMIZED && wParam != SIZE_MINIMIZED)
    {
      GetWindowRect(hMainWnd, &rcMainWindow);
      rcMainWindow.right-=rcMainWindow.left;
      rcMainWindow.bottom-=rcMainWindow.top;
    }
    if (wParam != SIZE_MINIMIZED) nLastMainSize=wParam;

    SendMessage(hStatus, WM_SIZE, wParam, lParam);
    UpdateSize(LOWORD(lParam), HIWORD(lParam));
    return TRUE;
  }
  else if (uMsg == WM_DROPFILES)
  {
    if (SaveChangedW())
    {
      nPosition=nPositionOld;
      DragQueryFileW((HDROP)wParam, 0, wszFileBuffer, FILELIST_BUFFER_SIZE);
      OpenDocumentW(wszFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
      DragFinish((HDROP)wParam);
    }
  }
  else if (uMsg == WM_HOTKEY)
  {
    GetAtomNameW(wParam, wbuf, BUFFER_SIZE);
    CallPluginW(wbuf);
  }
  else if (uMsg == WM_LBUTTONDBLCLK)
  {
    if (bMDI)
    {
      if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
      CreateMDIWindowW(APP_MDI_CLASSW, L"", (bMdiMaximize == TRUE)?WS_MAXIMIZE:0, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hMdiClient, hInstance, 0);
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDM_RECENT_FILES)
    {
      int nDead;

      RecentFilesReadW();
      nDead=RecentFilesDeleteDeadW();
      RecentFilesSaveW();
      RecentFilesMenuW();

      API_LoadStringW(hLangLib, MSG_RECENTFILES_DELETED, wbuf, BUFFER_SIZE);
      wsprintfW(wbuf2, wbuf, nDead);
      MessageBoxW(hMainWnd, wbuf2, APP_MAIN_TITLEW, MB_OK|MB_ICONINFORMATION);
      return TRUE;
    }
    if (LOWORD(wParam) > IDM_RECENT_FILES && LOWORD(wParam) <= IDM_RECENT_FILES + nRecentFiles)
    {
      if (SaveChangedW())
      {
        lstrcpyW(wszFileBuffer, wszRecentNames[LOWORD(wParam) - IDM_RECENT_FILES - 1]);
        OpenDocumentW(wszFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
      }
      return TRUE;
    }
    if (LOWORD(wParam) >= IDM_LANGUAGE && LOWORD(wParam) <= IDM_LANGUAGE+nLangModules+1)
    {
      if (LOWORD(wParam) == IDM_LANGUAGE)
      {
        if (!*wszLangModule) return TRUE;
        wszLangModule[0]='\0';
      }
      else
      {
        GetMenuStringW(hMainMenu, LOWORD(wParam), wbuf, BUFFER_SIZE, MF_BYCOMMAND);
        wsprintfW(wbuf2, L"%s.dll", wbuf);
        if (!lstrcmpiW(wszLangModule, wbuf2)) return TRUE;
        lstrcpyW(wszLangModule, wbuf2);
      }
      API_LoadStringW(hLangLib, MSG_RESTART_PROGRAM, wbuf, BUFFER_SIZE);
      MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONEXCLAMATION);
      return TRUE;
    }

    if (LOWORD(wParam) == IDM_FILE_NEW)
    {
      DoFileNewW();
    }
    else if (LOWORD(wParam) == IDM_FILE_CREATENEW)
    {
      if (!bMDI)
      {
        if (nSaveSettings == SS_REGISTRY)
          RegSaveOptionsW();
        else
          IniSaveOptionsW();
      }
      DoFileNewWindowW(0);
    }
    else if (LOWORD(wParam) == IDM_FILE_OPEN)
    {
      DoFileOpenW();
    }
    else if (LOWORD(wParam) == IDM_FILE_REOPEN)
    {
      DoFileReopenAsW(0, nCurrentCodePage, bCurrentBOM);
    }
    else if (LOWORD(wParam) == IDM_FILE_SAVE)
    {
      DoFileSaveW();
    }
    else if (LOWORD(wParam) == IDM_FILE_SAVEAS)
    {
      DoFileSaveAsW();
    }
    else if (LOWORD(wParam) == IDM_FILE_PAGESETUP)
    {
      DoFilePageSetupW();
    }
    else if (LOWORD(wParam) == IDM_FILE_PRINT)
    {
      DoFilePrintW();
    }
    else if (LOWORD(wParam) == IDM_FILE_EXIT)
    {
      PostMessage(hMainWnd, WM_CLOSE, 0, 0);
    }
    else if (LOWORD(wParam) == IDM_EDIT_UNDO)
    {
      DoEditUndo(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_REDO)
    {
      DoEditRedo(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_CUT)
    {
      DoEditCut(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_COPY)
    {
      DoEditCopy(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_PASTE)
    {
      DoEditPaste(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_PASTEANSI)
    {
      DoEditPasteANSI(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_CLEAR)
    {
      DoEditClear(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_SELECTALL)
    {
      DoEditSelectAll(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_INSERTCHAR)
    {
      DoEditInsertChar();
    }
    else if (LOWORD(wParam) == IDM_EDIT_RECODE)
    {
      DoEditRecodeW(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_INSERT_TAB_MENU ||
             LOWORD(wParam) == IDM_EDIT_INSERT_TAB)
    {
      if (!DoEditInsertStringInSelectionW(hWndEdit, STRSEL_CHECK, NULL))
        InsertTabStopW(hWndEdit);
      else
        IndentTabStopW(hWndEdit, STRSEL_INSERT|STRSEL_TAB);
    }
    else if (LOWORD(wParam) == IDM_EDIT_DELETE_TAB_MENU ||
             LOWORD(wParam) == IDM_EDIT_DELETE_TAB)
    {
      if (!DoEditInsertStringInSelectionW(hWndEdit, STRSEL_CHECK, NULL))
        InsertTabStopW(hWndEdit);
      else
        IndentTabStopW(hWndEdit, STRSEL_DELETE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_INSERT_SPACE_MENU ||
             LOWORD(wParam) == IDM_EDIT_INSERT_SPACE)
    {
      if (!DoEditInsertStringInSelectionW(hWndEdit, STRSEL_CHECK, NULL))
        SendMessage(hWndEdit, WM_CHAR, (WPARAM)' ', 0);
      else
        DoEditInsertStringInSelectionW(hWndEdit, STRSEL_INSERT, L" ");
    }
    else if (LOWORD(wParam) == IDM_EDIT_DELETE_SPACE_MENU ||
             LOWORD(wParam) == IDM_EDIT_DELETE_SPACE)
    {
      if (!DoEditInsertStringInSelectionW(hWndEdit, STRSEL_CHECK, NULL))
        SendMessage(hWndEdit, WM_CHAR, (WPARAM)' ', 0);
      else
        DoEditInsertStringInSelectionW(hWndEdit, STRSEL_DELETE|STRSEL_SPACE, L" ");
    }
    else if (LOWORD(wParam) == IDM_EDIT_DELETE_TRAILING_WHITESPACES)
    {
      DoEditDeleteTrailingWhitespacesW(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_UPPERCASE)
    {
      DoEditChangeCaseW(hWndEdit, UPPERCASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_LOWERCASE)
    {
      DoEditChangeCaseW(hWndEdit, LOWERCASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_SENTENCECASE)
    {
      DoEditChangeCaseW(hWndEdit, SENTENCECASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_TITLECASE)
    {
      DoEditChangeCaseW(hWndEdit, TITLECASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_INVERTCASE)
    {
      DoEditChangeCaseW(hWndEdit, INVERTCASE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_NEWLINE_WIN)
    {
      SetNewLineW(NEWLINE_WIN, FALSE);
      SetModifyW(TRUE, FALSE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_NEWLINE_UNIX)
    {
      SetNewLineW(NEWLINE_UNIX, FALSE);
      SetModifyW(TRUE, FALSE);
    }
    else if (LOWORD(wParam) == IDM_EDIT_FIND)
    {
      DoEditFindW();
    }
    else if (LOWORD(wParam) == IDM_EDIT_FINDNEXTDOWN)
    {
      DoEditFindNextDownW(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_FINDNEXTUP)
    {
      DoEditFindNextUpW(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_EDIT_REPLACE)
    {
      DoEditReplaceW();
    }
    else if (LOWORD(wParam) == IDM_EDIT_GOTOLINE)
    {
      DoEditGoToLineW();
    }
    else if (LOWORD(wParam) == IDM_VIEW_FONT)
    {
      DoViewFontW(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_VIEW_TEXT_COLOR)
    {
      DoViewTextColorW(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_VIEW_BG_COLOR)
    {
      DoViewBGColorW(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_VIEW_INCREASE_FONT)
    {
      DoViewFontSizeW(hWndEdit, INCREASE_FONT);
    }
    else if (LOWORD(wParam) == IDM_VIEW_DECREASE_FONT)
    {
      DoViewFontSizeW(hWndEdit, DECREASE_FONT);
    }
    else if (LOWORD(wParam) == IDM_VIEW_ALIGN_CENTER)
    {
      DoViewAlignment(hWndEdit, PFA_CENTER);
    }
    else if (LOWORD(wParam) == IDM_VIEW_ALIGN_RIGHT)
    {
      DoViewAlignment(hWndEdit, PFA_RIGHT);
    }
    else if (LOWORD(wParam) == IDM_VIEW_ALIGN_LEFT)
    {
      DoViewAlignment(hWndEdit, PFA_LEFT);
    }
    else if (LOWORD(wParam) == IDM_VIEW_WORDWRAP)
    {
      DoViewWordWrap(hWndEdit, !bWordWrap, FALSE);
    }
    else if (LOWORD(wParam) == IDM_VIEW_ONTOP)
    {
      DoViewOnTop(!bOnTop, FALSE);
    }
    else if (LOWORD(wParam) == IDM_VIEW_SHOW_STATUSBAR)
    {
      DoViewShowStatusBar(!bStatusBar, FALSE);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_EXEC)
    {
      DoSettingsExecW();
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_SAVETIME)
    {
      DoSettingsSaveTime(!bSaveTime);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_KEEPSPACE)
    {
      DoSettingsKeepSpace(!bKeepSpace);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_WATCHFILE)
    {
      DoSettingsWatchFileW(!bWatchFile);
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_SINGLEOPEN_FILE)
    {
      DoSettingsSingleOpenFile(!bSingleOpenFile);
      if (nSaveSettings == SS_REGISTRY)
        RegSaveOptionsW();
      else
        IniSaveOptionsW();
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_SINGLEOPEN_PROGRAM)
    {
      DoSettingsSingleOpenProgram(!bSingleOpenProgram);
      if (nSaveSettings == SS_REGISTRY)
        RegSaveOptionsW();
      else
        IniSaveOptionsW();
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_SDI)
    {
      if (bRegMDI)
      {
        API_LoadStringW(hLangLib, MSG_RESTART_PROGRAM, wbuf, BUFFER_SIZE);
        MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONEXCLAMATION);
        bRegMDI=FALSE;
      }
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_MDI)
    {
      if (!bRegMDI)
      {
        API_LoadStringW(hLangLib, MSG_RESTART_PROGRAM, wbuf, BUFFER_SIZE);
        MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONEXCLAMATION);
        bRegMDI=TRUE;
      }
    }
    else if (LOWORD(wParam) == IDM_OPTIONS)
    {
      DoSettingsOptionsW();
    }
    else if (LOWORD(wParam) == IDM_OPTIONS_PLUGINS)
    {
      DoSettingsPluginsW(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_ABOUT)
    {
      DoHelpAboutW();
    }
    else if (LOWORD(wParam) == IDM_NONMENU_CHANGESIZE)
    {
      ShowWindow(hMainWnd, (GetWindowLong(hMainWnd, GWL_STYLE) & WS_MAXIMIZE)?SW_RESTORE:SW_MAXIMIZE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_DELLINE)
    {
      DoNonMenuDelLine(hWndEdit);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPENAS_ANSI)
    {
      DoFileReopenAsW(0, nAnsiCodePage, FALSE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPENAS_OEM)
    {
      DoFileReopenAsW(0, nOemCodePage, FALSE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPENAS_UTF8)
    {
      DoFileReopenAsW(ADT_DETECT_BOM, CP_UNICODE_UTF8, FALSE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPENAS_KOIR)
    {
      DoFileReopenAsW(0, CP_KOI8_R, FALSE);
    }
    else if (LOWORD(wParam) == IDM_NONMENU_REOPEN_MSG)
    {
      API_LoadStringW(hLangLib, MSG_FILE_CHANGED, wbuf, BUFFER_SIZE);
      wsprintfW(wbuf2, wbuf, wszCurrentFile);
      if (MessageBoxW(hMainWnd, wbuf2, APP_MAIN_TITLEW, bModified?MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2:MB_YESNO|MB_ICONQUESTION) == IDYES)
      {
        bMdiReopen=TRUE;
        OpenDocumentW(wszCurrentFile, 0, nCurrentCodePage, bCurrentBOM);
        bMdiReopen=FALSE;
      }
    }
    else if (LOWORD(wParam) == IDM_NONMENU_SETFILEPRINT)
    {
      bGlobalPrint=TRUE;
    }
    else if (LOWORD(wParam) == IDM_NONMENU_SETMSGCREATE)
    {
      nMsgCreate=(int)lParam;
    }
    else if (LOWORD(wParam) == IDM_NONMENU_SETMSGBINARY)
    {
      nMsgBinary=(int)lParam;
    }
    else if (LOWORD(wParam) == IDM_NONMENU_FILEOPEN)
    {
      if (bMDI || SaveChangedW())
      {
        GlobalGetAtomNameW(HIWORD(wParam), wszFileBuffer, FILELIST_BUFFER_SIZE);
        OpenDocumentW(wszFileBuffer, LOWORD(lParam), HIWORD(lParam), FALSE);
      }
    }

    if (bMDI)
    {
      if (LOWORD(wParam) == IDM_WINDOW_TABVIEW_TOP)
      {
        DoWindowTabView(TAB_VIEW_TOP, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABVIEW_BOTTOM)
      {
        DoWindowTabView(TAB_VIEW_BOTTOM, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABVIEW_NONE)
      {
        DoWindowTabView(TAB_VIEW_NONE, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABTYPE_STANDART)
      {
        DoWindowTabType(TAB_TYPE_STANDART, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABTYPE_BUTTONS)
      {
        DoWindowTabType(TAB_TYPE_BUTTONS, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TABTYPE_FLATBUTTONS)
      {
        DoWindowTabType(TAB_TYPE_FLATBUTTONS, FALSE);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TILEHORIZONTAL)
      {
        PostMessage(hMdiClient, WM_MDITILE, MDITILE_HORIZONTAL, 0);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_TILEVERTICAL)
      {
        PostMessage(hMdiClient, WM_MDITILE, MDITILE_VERTICAL, 0);
      }
      else if (LOWORD(wParam) == IDM_WINDOW_CASCADE)
      {
        PostMessage(hMdiClient, WM_MDICASCADE, 0, 0);
      }
      else if (LOWORD(wParam) == IDM_NONMENU_MDINEXT)
      {
        PostMessage(hMdiClient, WM_MDINEXT, (WPARAM)hWndMdiActive, FALSE);
      }
      else if (LOWORD(wParam) == IDM_NONMENU_MDIPREV)
      {
        PostMessage(hMdiClient, WM_MDINEXT, (WPARAM)hWndMdiActive, TRUE);
      }
      else if (LOWORD(wParam) == IDM_NONMENU_MDICLOSE)
      {
        PostMessage(hMdiClient, WM_MDIDESTROY, (WPARAM)hWndMdiActive, 0);
      }
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (wParam == ID_STATUS && (!bMDI || hWndMdiActive))
    {
      if (((NMHDR *)lParam)->code == NM_DBLCLK)
      {
        if (((LPNMMOUSE)lParam)->dwItemSpec == 0)
        {
          DoEditGoToLineW();
        }
        else if (((LPNMMOUSE)lParam)->dwItemSpec == 2)
        {
          SendMessage(hWndEdit, WM_KEYDOWN, VK_INSERT, 0x00520001);
          SendMessage(hWndEdit, WM_KEYUP, VK_INSERT, 0xC0520001);
        }
        else if (((LPNMMOUSE)lParam)->dwItemSpec == 3)
        {
          if (nNewLine == NEWLINE_WIN) SetNewLineW(NEWLINE_UNIX, FALSE);
          else if (nNewLine == NEWLINE_UNIX) SetNewLineW(NEWLINE_WIN, FALSE);
          SetModifyW(TRUE, FALSE);
        }
      }
    }

    if (bMDI)
    {
      if (wParam == ID_TAB)
      {
        if (((NMHDR *)lParam)->code == TCN_SELCHANGE)
        {
          TCITEMW tcItemW;

          bTabPressed=TRUE;
          i=SendMessage(hTab, TCM_GETCURSEL, 0, 0);
          tcItemW.mask=TCIF_PARAM;
          SendMessage(hTab, TCM_GETITEMW, (WPARAM)i, (LPARAM)&tcItemW);
          SendMessage(hMdiClient, WM_MDIACTIVATE, (WPARAM)tcItemW.lParam, 0);
        }
      }
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    if (!bMDI)
    {
      if (!DoFileExitW()) return TRUE;
      DestroyWindow(hWndEdit);
    }
    else
    {
      while (hWndMdiActive)
      {
        SendMessage(hMdiClient, WM_MDIDESTROY, (WPARAM)hWndMdiActive, 0);
        if (!bFileExitError) return TRUE;
      }
    }
    DestroyWindow(hMainWnd);
  }
  else if (uMsg == WM_DESTROY)
  {
    //Save options
    if (nSaveSettings == SS_REGISTRY)
      RegSaveOptionsW();
    else
      IniSaveOptionsW();

    //Clean up
    if (bMDI)
    {
      DeleteObject(hTabFont);
      ImageList_Destroy(hImageList);
    }
    DestroyAcceleratorTable(hMainAccel);
    DestroyIcon(hMainIcon);
    DestroyIcon(hIconEmpty);
    DestroyMenu(hMainMenu);
    DestroyMenu(hPopupMenu);
    FreeMemoryRecentFilesW();
    FreeMemorySearchW();

    PostQuitMessage(0);
  }

  if (!bMDI)
  {
    if (MdiProcW(hMainWnd, uMsg, wParam, lParam) == TRUE) return TRUE;

    return DefWindowProcW(hMainWnd, uMsg, wParam, lParam);
  }
  else
  {
    return DefFrameProcW(hMainWnd, hMdiClient, uMsg, wParam, lParam);
  }
}

LRESULT CALLBACK MdiProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  int i;

  if (uMsg == WM_SETFOCUS)
  {
    SetFocus(hWndEdit);

    if (bWatchFile && *szCurrentFile)
    {
      FILETIME tmp;

      GetFileWriteTimeA(szCurrentFile, &tmp);

      if (CompareFileTime(&ft, &tmp))
      {
        memcpy(&ft, &tmp, sizeof(FILETIME));
        PostMessage(hMainWnd, WM_COMMAND, IDM_NONMENU_REOPEN_MSG, 0);
      }
    }
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    if ((HWND)wParam == hWndEdit)
    {
      RECT rcRect;
      POINT pt;

      if (lParam == ((UINT)-1))
      {
        GetWindowRect((HWND)wParam, &rcRect);
        pt.x=rcRect.left;
        pt.y=rcRect.top;
      }
      else
      {
        pt.x=LOWORD(lParam);
        pt.y=HIWORD(lParam);
      }
      EnableMenuItem(hPopupEdit, IDM_EDIT_UNDO, SendMessage(hWndEdit, EM_CANUNDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_REDO, SendMessage(hWndEdit, EM_CANREDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_CUT, (chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_COPY, (chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_PASTE, SendMessage(hWndEdit, EM_CANPASTE, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_CLEAR, (chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED);
      TrackPopupMenu(hPopupEdit, TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hMainWnd, NULL);
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == ID_EDIT)
    {
      if (HIWORD(wParam) == EN_CHANGE)
      {
        SetModifyA(TRUE, FALSE);
      }
      else if (HIWORD(wParam) == EN_MAXTEXT)
      {
        //trying to reallocate
        API_LoadStringA(hLangLib, MSG_ERROR_LIMIT_REACHED, buf, BUFFER_SIZE);
        MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
        nMaxChars+=nMcstep;
        SendMessage(hWndEdit, EM_EXLIMITTEXT, 0, nMaxChars);
      }
      else if (HIWORD(wParam) == EN_ERRSPACE)
      {
        API_LoadStringA(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY_FOR_RICHEDIT, buf, BUFFER_SIZE);
        MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
        ExitProcess(1);
      }
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (wParam == ID_EDIT)
    {
      if (((NMHDR *)lParam)->code == EN_SELCHANGE)
      {
        CHARRANGE cr;
        int nLine;
        int nColumn;
        int nLinebreaks=0;

        SendMessage(hWndEdit, EM_EXGETSEL, 0, (LPARAM)&cr);
        nPositionOld=nPosition;
        nPosition=(cr.cpMin == chrg.cpMin || cr.cpMin == chrg.cpMax)?cr.cpMax:cr.cpMin;
        chrg.cpMin=cr.cpMin;
        chrg.cpMax=cr.cpMax;

        nLine=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, nPosition) + 1;
        nColumn=SendMessage(hWndEdit, EM_LINEINDEX, nLine - 1, 0);
        nColumn=nPosition - nColumn + 1;

        if (chrg.cpMin == chrg.cpMax)
        {
          wsprintf(buf, "%u:%u", nLine, nColumn);
        }
        else
        {
          if (nNewLine == NEWLINE_WIN) nLinebreaks=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, chrg.cpMax) - SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, chrg.cpMin);
          wsprintf(buf, "%u:%u, %u", nLine, nColumn, chrg.cpMax - chrg.cpMin + nLinebreaks);
        }
        SendMessage(hStatus, SB_SETTEXT, 0, (LPARAM)buf);
      }
    }
  }
  if (!bMDI) return FALSE;

  if (uMsg == WM_CREATE)
  {
    if (lpWindowData=(MDIWINDOWDATA *)API_HeapAlloc(hHeap, 0, sizeof(MDIWINDOWDATA)))
    {
      TCITEM tcItem;

      CreateEditWindowA(hWnd);

      lpWindowData->hIcon=hIconEmpty;
      lpWindowData->bWordWrap=bWordWrap;
      lpWindowData->nNewLine=NEWLINE_WIN;
      lpWindowData->bInsertState=FALSE;
      lpWindowData->bModified=FALSE;
      lpWindowData->nCodePage=MAKELONG(nDefaultCodePage, bDefaultBOM);
      SetWindowLong(hWnd, GWL_USERDATA, (LONG)lpWindowData);

      i=ImageList_AddIcon(hImageList, hIconEmpty);
      tcItem.mask=TCIF_TEXT|TCIF_IMAGE|TCIF_PARAM;
      tcItem.pszText="";
      tcItem.iImage=i;
      tcItem.lParam=(LPARAM)hWnd;
      i=SendMessage(hTab, TCM_GETITEMCOUNT, 0, 0);
      SendMessage(hTab, TCM_INSERTITEM, i, (LPARAM)&tcItem);
      SendMessage(hWnd, WM_SETICON, ICON_SMALL, (LPARAM)hIconEmpty);

      if (!hWndMdiActive) InvalidateRect(hTab, NULL, TRUE);
    }
  }
  else if (uMsg == WM_SIZE)
  {
    HWND hWndMove;
    int nBeforeLine;
    int nAfterLine;

    if (wParam != SIZE_MINIMIZED)
    {
      if (hWndMove=GetDlgItem(hWnd, ID_EDIT))
      {
        nBeforeLine=SendMessage(hWndMove, EM_GETFIRSTVISIBLELINE, 0, 0);
        MoveWindow(hWndMove, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
        nAfterLine=SendMessage(hWndMove, EM_GETFIRSTVISIBLELINE, 0, 0);
        if (nBeforeLine != nAfterLine)
        {
          if (bOldRichEdit)
          {
            SendMessage(hWndMove, EM_LINESCROLL, 0, -1);
            SendMessage(hWndMove, EM_LINESCROLL, 0, nBeforeLine);
          }
          else SendMessage(hWndMove, EM_LINESCROLL, 0, nBeforeLine - nAfterLine);
        }
      }
    }
  }
  else if (uMsg == WM_MDIACTIVATE)
  {
    TCITEM tcItem;
    NMHDR nmhdr;
    int nMessages[]={IDM_FILE_REOPEN,
                     IDM_FILE_SAVE,
                     IDM_FILE_SAVEAS,
                     IDM_FILE_PAGESETUP,
                     IDM_FILE_PRINT,
                     IDM_EDIT_UNDO,
                     IDM_EDIT_REDO,
                     IDM_EDIT_CUT,
                     IDM_EDIT_COPY,
                     IDM_EDIT_PASTE,
                     IDM_EDIT_CLEAR,
                     IDM_EDIT_SELECTALL,
                     IDM_EDIT_FIND,
                     IDM_EDIT_FINDNEXTDOWN,
                     IDM_EDIT_FINDNEXTUP,
                     IDM_EDIT_REPLACE,
                     IDM_EDIT_GOTOLINE,
                     IDM_EDIT_INSERT_TAB_MENU,
                     IDM_EDIT_DELETE_TAB_MENU,
                     IDM_EDIT_INSERT_SPACE_MENU,
                     IDM_EDIT_DELETE_SPACE_MENU,
                     IDM_EDIT_DELETE_TRAILING_WHITESPACES,
                     IDM_EDIT_UPPERCASE,
                     IDM_EDIT_LOWERCASE,
                     IDM_EDIT_SENTENCECASE,
                     IDM_EDIT_TITLECASE,
                     IDM_EDIT_INVERTCASE,
                     IDM_EDIT_NEWLINE_WIN,
                     IDM_EDIT_NEWLINE_UNIX,
                     IDM_EDIT_RECODE,
                     IDM_VIEW_FONT,
                     IDM_VIEW_TEXT_COLOR,
                     IDM_VIEW_BG_COLOR,
                     IDM_VIEW_INCREASE_FONT,
                     IDM_VIEW_DECREASE_FONT,
                     IDM_VIEW_ALIGN_LEFT,
                     IDM_VIEW_ALIGN_CENTER,
                     IDM_VIEW_ALIGN_RIGHT,
                     IDM_VIEW_WORDWRAP,
                     IDM_WINDOW_TILEHORIZONTAL,
                     IDM_WINDOW_TILEVERTICAL,
                     IDM_WINDOW_CASCADE,
                     0};

    hWndEdit=GetDlgItem((HWND)lParam, ID_EDIT);

    if (!lParam)
    {
      for (i=0; nMessages[i]; ++i)
        EnableMenuItem(hMainMenu, nMessages[i], MF_GRAYED);
      bMdiNoWindows=TRUE;

      for (i=0; i < 5; ++i)
        SendMessage(hStatus, SB_SETTEXT, i, (LPARAM)"");
      szCurrentFile[0]='\0';
      bModified=FALSE;
    }
    else if (bMdiNoWindows)
    {
      for (i=0; nMessages[i]; ++i)
        EnableMenuItem(hMainMenu, nMessages[i], MF_ENABLED);
      bMdiNoWindows=FALSE;

      SetNewLineA(NEWLINE_WIN, TRUE);
      SetInsertStateA(FALSE, TRUE);
      SetModifyA(FALSE, TRUE);
      SetCodePageA(MAKELONG(nDefaultCodePage, bDefaultBOM), TRUE);
    }

    if ((HWND)lParam != hWndMdiActive)
    {
      hWndMdiActive=(HWND)lParam;

      if (lParam && wParam && (HWND)wParam != hWndMdiDestroyed)
      {
        //Save deactivated MDI window settings
        lpWindowData=(MDIWINDOWDATA *)GetWindowLong((HWND)wParam, GWL_USERDATA);
        lpWindowData->bWordWrap=bWordWrap;
        lpWindowData->nNewLine=nNewLine;
        lpWindowData->bInsertState=bInsertState;
        lpWindowData->bModified=bModified;
        lpWindowData->nCodePage=MAKELONG(nCurrentCodePage, bCurrentBOM);
        memcpy(&lpWindowData->ft, &ft, sizeof(FILETIME));
      }
      if (lParam)
      {
        //Set activated MDI window settings
        lpWindowData=(MDIWINDOWDATA *)GetWindowLong((HWND)lParam, GWL_USERDATA);
        bWordWrap=lpWindowData->bWordWrap;
        SetNewLineA(lpWindowData->nNewLine, FALSE);
        SetInsertStateA(lpWindowData->bInsertState, FALSE);
        SetModifyA(lpWindowData->bModified, FALSE);
        SetCodePageA(lpWindowData->nCodePage, FALSE);
        memcpy(&ft, &lpWindowData->ft, sizeof(FILETIME));

        nmhdr.hwndFrom=hWndEdit;
        nmhdr.idFrom=ID_EDIT;
        nmhdr.code=EN_SELCHANGE;
        SendMessage((HWND)lParam, WM_NOTIFY, ID_EDIT, (LPARAM)&nmhdr);

        CheckMenuItem(hMainMenu, IDM_VIEW_WORDWRAP, bWordWrap?MF_CHECKED:MF_UNCHECKED);
        GetWindowText((HWND)lParam, szCurrentFile, MAX_PATH);

        //Select tab
        if (!bTabPressed)
        {
          tcItem.mask=TCIF_PARAM;

          for (i=0; SendMessage(hTab, TCM_GETITEM, (WPARAM)i, (LPARAM)&tcItem); ++i)
          {
            if (tcItem.lParam == lParam)
            {
              SendMessage(hTab, TCM_SETCURSEL, (WPARAM)i, 0);
              break;
            }
          }
        }
        else bTabPressed=FALSE;
      }
    }
  }
  return DefMDIChildProc(hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK MdiProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  int i;

  if (uMsg == WM_SETFOCUS)
  {
    SetFocus(hWndEdit);

    if (bWatchFile && *wszCurrentFile)
    {
      FILETIME tmp;

      GetFileWriteTimeW(wszCurrentFile, &tmp);

      if (CompareFileTime(&ft, &tmp))
      {
        memcpy(&ft, &tmp, sizeof(FILETIME));
        PostMessage(hMainWnd, WM_COMMAND, IDM_NONMENU_REOPEN_MSG, 0);
      }
    }
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    if ((HWND)wParam == hWndEdit)
    {
      RECT rcRect;
      POINT pt;

      if (lParam == ((UINT)-1))
      {
        GetWindowRect((HWND)wParam, &rcRect);
        pt.x=rcRect.left;
        pt.y=rcRect.top;
      }
      else
      {
        pt.x=LOWORD(lParam);
        pt.y=HIWORD(lParam);
      }
      EnableMenuItem(hPopupEdit, IDM_EDIT_UNDO, SendMessage(hWndEdit, EM_CANUNDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_REDO, SendMessage(hWndEdit, EM_CANREDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_CUT, (chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_COPY, (chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_PASTE, SendMessage(hWndEdit, EM_CANPASTE, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hPopupEdit, IDM_EDIT_CLEAR, (chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED);
      TrackPopupMenu(hPopupEdit, TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hMainWnd, NULL);
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == ID_EDIT)
    {
      if (HIWORD(wParam) == EN_CHANGE)
      {
        SetModifyW(TRUE, FALSE);
      }
      else if (HIWORD(wParam) == EN_MAXTEXT)
      {
        //trying to reallocate
        API_LoadStringW(hLangLib, MSG_ERROR_LIMIT_REACHED, wbuf, BUFFER_SIZE);
        MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
        nMaxChars+=nMcstep;
        SendMessage(hWndEdit, EM_EXLIMITTEXT, 0, nMaxChars);
      }
      else if (HIWORD(wParam) == EN_ERRSPACE)
      {
        API_LoadStringW(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY_FOR_RICHEDIT, wbuf, BUFFER_SIZE);
        MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
        ExitProcess(1);
      }
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (wParam == ID_EDIT)
    {
      if (((NMHDR *)lParam)->code == EN_SELCHANGE)
      {
        CHARRANGE cr;
        int nLine;
        int nColumn;
        int nLinebreaks=0;

        SendMessage(hWndEdit, EM_EXGETSEL, 0, (LPARAM)&cr);
        nPositionOld=nPosition;
        nPosition=(cr.cpMin == chrg.cpMin || cr.cpMin == chrg.cpMax)?cr.cpMax:cr.cpMin;
        chrg.cpMin=cr.cpMin;
        chrg.cpMax=cr.cpMax;

        nLine=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, nPosition) + 1;
        nColumn=SendMessage(hWndEdit, EM_LINEINDEX, nLine - 1, 0);
        nColumn=nPosition - nColumn + 1;

        if (chrg.cpMin == chrg.cpMax)
        {
          wsprintfW(wbuf, L"%u:%u", nLine, nColumn);
        }
        else
        {
          if (nNewLine == NEWLINE_WIN) nLinebreaks=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, chrg.cpMax) - SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, chrg.cpMin);
          wsprintfW(wbuf, L"%u:%u, %u", nLine, nColumn, chrg.cpMax - chrg.cpMin + nLinebreaks);
        }
        SendMessage(hStatus, SB_SETTEXTW, 0, (LPARAM)wbuf);
      }
    }
  }
  if (!bMDI) return FALSE;

  if (uMsg == WM_CREATE)
  {
    TCITEMW tcItemW;

    if (lpWindowData=(MDIWINDOWDATA *)API_HeapAlloc(hHeap, 0, sizeof(MDIWINDOWDATA)))
    {
      CreateEditWindowW(hWnd);

      lpWindowData->hIcon=hIconEmpty;
      lpWindowData->bWordWrap=bWordWrap;
      lpWindowData->nNewLine=NEWLINE_WIN;
      lpWindowData->bInsertState=FALSE;
      lpWindowData->bModified=FALSE;
      lpWindowData->nCodePage=MAKELONG(nDefaultCodePage, bDefaultBOM);
      SetWindowLong(hWnd, GWL_USERDATA, (LONG)lpWindowData);

      i=ImageList_AddIcon(hImageList, hIconEmpty);
      tcItemW.mask=TCIF_TEXT|TCIF_IMAGE|TCIF_PARAM;
      tcItemW.pszText=L"";
      tcItemW.iImage=i;
      tcItemW.lParam=(LPARAM)hWnd;
      i=SendMessage(hTab, TCM_GETITEMCOUNT, 0, 0);
      SendMessage(hTab, TCM_INSERTITEMW, i, (LPARAM)&tcItemW);
      SendMessage(hWnd, WM_SETICON, ICON_SMALL, (LPARAM)hIconEmpty);

      if (!hWndMdiActive) InvalidateRect(hTab, NULL, TRUE);
    }
  }
  else if (uMsg == WM_SIZE)
  {
    HWND hWndMove;
    int nBeforeLine;
    int nAfterLine;

    if (wParam != SIZE_MINIMIZED)
    {
      if (hWndMove=GetDlgItem(hWnd, ID_EDIT))
      {
        nBeforeLine=SendMessage(hWndMove, EM_GETFIRSTVISIBLELINE, 0, 0);
        MoveWindow(hWndMove, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
        nAfterLine=SendMessage(hWndMove, EM_GETFIRSTVISIBLELINE, 0, 0);
        if (nBeforeLine != nAfterLine)
        {
          if (bOldRichEdit)
          {
            SendMessage(hWndMove, EM_LINESCROLL, 0, -1);
            SendMessage(hWndMove, EM_LINESCROLL, 0, nBeforeLine);
          }
          else SendMessage(hWndMove, EM_LINESCROLL, 0, nBeforeLine - nAfterLine);
        }
      }
    }
  }
  else if (uMsg == WM_MDIACTIVATE)
  {
    TCITEMW tcItemW;
    NMHDR nmhdr;
    int nMessages[]={IDM_FILE_REOPEN,
                     IDM_FILE_SAVE,
                     IDM_FILE_SAVEAS,
                     IDM_FILE_PAGESETUP,
                     IDM_FILE_PRINT,
                     IDM_EDIT_UNDO,
                     IDM_EDIT_REDO,
                     IDM_EDIT_CUT,
                     IDM_EDIT_COPY,
                     IDM_EDIT_PASTE,
                     IDM_EDIT_CLEAR,
                     IDM_EDIT_SELECTALL,
                     IDM_EDIT_FIND,
                     IDM_EDIT_FINDNEXTDOWN,
                     IDM_EDIT_FINDNEXTUP,
                     IDM_EDIT_REPLACE,
                     IDM_EDIT_GOTOLINE,
                     IDM_EDIT_INSERT_TAB_MENU,
                     IDM_EDIT_DELETE_TAB_MENU,
                     IDM_EDIT_INSERT_SPACE_MENU,
                     IDM_EDIT_DELETE_SPACE_MENU,
                     IDM_EDIT_DELETE_TRAILING_WHITESPACES,
                     IDM_EDIT_UPPERCASE,
                     IDM_EDIT_LOWERCASE,
                     IDM_EDIT_SENTENCECASE,
                     IDM_EDIT_TITLECASE,
                     IDM_EDIT_INVERTCASE,
                     IDM_EDIT_NEWLINE_WIN,
                     IDM_EDIT_NEWLINE_UNIX,
                     IDM_EDIT_RECODE,
                     IDM_VIEW_FONT,
                     IDM_VIEW_TEXT_COLOR,
                     IDM_VIEW_BG_COLOR,
                     IDM_VIEW_INCREASE_FONT,
                     IDM_VIEW_DECREASE_FONT,
                     IDM_VIEW_ALIGN_LEFT,
                     IDM_VIEW_ALIGN_CENTER,
                     IDM_VIEW_ALIGN_RIGHT,
                     IDM_VIEW_WORDWRAP,
                     IDM_WINDOW_TILEHORIZONTAL,
                     IDM_WINDOW_TILEVERTICAL,
                     IDM_WINDOW_CASCADE,
                     0};

    hWndEdit=GetDlgItem((HWND)lParam, ID_EDIT);

    if (!lParam)
    {
      for (i=0; nMessages[i]; ++i)
        EnableMenuItem(hMainMenu, nMessages[i], MF_GRAYED);
      bMdiNoWindows=TRUE;

      for (i=0; i < 5; ++i)
        SendMessage(hStatus, SB_SETTEXTW, i, (LPARAM)L"");
      wszCurrentFile[0]='\0';
      bModified=FALSE;
    }
    else if (bMdiNoWindows)
    {
      for (i=0; nMessages[i]; ++i)
        EnableMenuItem(hMainMenu, nMessages[i], MF_ENABLED);
      bMdiNoWindows=FALSE;

      SetNewLineW(NEWLINE_WIN, TRUE);
      SetInsertStateW(FALSE, TRUE);
      SetModifyW(FALSE, TRUE);
      SetCodePageW(MAKELONG(nDefaultCodePage, bDefaultBOM), TRUE);
    }

    if ((HWND)lParam != hWndMdiActive)
    {
      hWndMdiActive=(HWND)lParam;

      if (lParam && wParam && (HWND)wParam != hWndMdiDestroyed)
      {
        //Save deactivated MDI window settings
        lpWindowData=(MDIWINDOWDATA *)GetWindowLong((HWND)wParam, GWL_USERDATA);
        lpWindowData->bWordWrap=bWordWrap;
        lpWindowData->nNewLine=nNewLine;
        lpWindowData->bInsertState=bInsertState;
        lpWindowData->bModified=bModified;
        lpWindowData->nCodePage=MAKELONG(nCurrentCodePage, bCurrentBOM);
        memcpy(&lpWindowData->ft, &ft, sizeof(FILETIME));
      }
      if (lParam)
      {
        //Set activated MDI window settings
        lpWindowData=(MDIWINDOWDATA *)GetWindowLong((HWND)lParam, GWL_USERDATA);
        bWordWrap=lpWindowData->bWordWrap;
        SetNewLineW(lpWindowData->nNewLine, FALSE);
        SetInsertStateW(lpWindowData->bInsertState, FALSE);
        SetModifyW(lpWindowData->bModified, FALSE);
        SetCodePageW(lpWindowData->nCodePage, FALSE);
        memcpy(&ft, &lpWindowData->ft, sizeof(FILETIME));

        nmhdr.hwndFrom=hWndEdit;
        nmhdr.idFrom=ID_EDIT;
        nmhdr.code=EN_SELCHANGE;
        SendMessage((HWND)lParam, WM_NOTIFY, ID_EDIT, (LPARAM)&nmhdr);

        CheckMenuItem(hMainMenu, IDM_VIEW_WORDWRAP, bWordWrap?MF_CHECKED:MF_UNCHECKED);
        GetWindowTextW((HWND)lParam, wszCurrentFile, MAX_PATH);

        //Select tab
        if (!bTabPressed)
        {
          tcItemW.mask=TCIF_PARAM;

          for (i=0; SendMessage(hTab, TCM_GETITEMW, (WPARAM)i, (LPARAM)&tcItemW); ++i)
          {
            if (tcItemW.lParam == lParam)
            {
              SendMessage(hTab, TCM_SETCURSEL, (WPARAM)i, 0);
              break;
            }
          }
        }
        else bTabPressed=FALSE;
      }
    }
  }
  return DefMDIChildProcW(hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK DummyWndProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK DummyWndProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  return DefWindowProcW(hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewEditProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  int i;

  if (uMsg == WM_KEYDOWN && wParam == VK_RETURN && bKeepSpace)
  {
    TEXTRANGE txtrng;
    int nMinLine;
    int nMinLineIndex;
    int textsize;
    int a;
    char *pText;

    nMinLine=SendMessage(hWndEdit, EM_LINEFROMCHAR, chrg.cpMin, 0);
    nMinLineIndex=SendMessage(hWndEdit, EM_LINEINDEX, nMinLine, 0);
    txtrng.chrg.cpMin=nMinLineIndex;
    txtrng.chrg.cpMax=chrg.cpMin;
    textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin;

    if (textsize)
    {
      if (pText=(char *)API_HeapAlloc(hHeap, 0, textsize + 2))
      {
        txtrng.lpstrText=pText + 1;
        SendMessage(hWndEdit, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);

        for (a=1, pText[0]='\n'; pText[a] == ' ' || pText[a] == '\t'; ++a);

        pText[a]='\0';
      }

      SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)pText);
      API_HeapFree(hHeap, 0, (LPVOID)pText);
      return TRUE;
    }
  }
  else if (uMsg == WM_KEYDOWN && wParam == VK_INSERT)
  {
    if (GetKeyState(VK_SHIFT) >= 0 && GetKeyState(VK_CONTROL) >= 0)
    {
      SetInsertStateA(!bInsertState, FALSE);
    }
  }
  else if (uMsg == WM_MOUSEWHEEL)
  {
    if (LOWORD(wParam) == MK_CONTROL)
    {
      if ((short)HIWORD(wParam) < 0)
        DoViewFontSizeA(hWndEdit, DECREASE_FONT);
      else
        DoViewFontSizeA(hWndEdit, INCREASE_FONT);
    }
    else
    {
      if ((short)HIWORD(wParam) < 0)
      {
        SCROLLINFO si;

        si.cbSize=sizeof(SCROLLINFO);
        si.fMask=SIF_PAGE|SIF_POS|SIF_RANGE;

        for (i=0; i < 3; ++i)
        {
          GetScrollInfo(hWndEdit, SB_VERT, &si);
          if (si.nPage > 0 && si.nPos + (int)si.nPage < si.nMax)
            SendMessage(hWndEdit, EM_SCROLL, SB_LINEDOWN, 0);
          else
            break;
        }
      }
      else
        for (i=0; i < 3; ++i) SendMessage(hWndEdit, EM_SCROLL, SB_LINEUP, 0);
    }
    return TRUE;
  }
  return CallWindowProc(OldEditProc, hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewEditProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  int i;

  if (uMsg == WM_KEYDOWN && wParam == VK_RETURN && bKeepSpace)
  {
    TEXTRANGE txtrng;
    int nMinLine;
    int nMinLineIndex;
    int textsize;
    int a;
    char *pText;

    nMinLine=SendMessage(hWndEdit, EM_LINEFROMCHAR, chrg.cpMin, 0);
    nMinLineIndex=SendMessage(hWndEdit, EM_LINEINDEX, nMinLine, 0);
    txtrng.chrg.cpMin=nMinLineIndex;
    txtrng.chrg.cpMax=chrg.cpMin;
    textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin;

    if (textsize)
    {
      if (pText=(char *)API_HeapAlloc(hHeap, 0, textsize + 2))
      {
        txtrng.lpstrText=pText + 1;
        SendMessage(hWndEdit, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);

        for (a=1, pText[0]='\n'; pText[a] == ' ' || pText[a] == '\t'; ++a);

        pText[a]='\0';
      }

      SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)pText);
      API_HeapFree(hHeap, 0, (LPVOID)pText);
      return TRUE;
    }
  }
  else if (uMsg == WM_KEYDOWN && wParam == VK_INSERT)
  {
    if (GetKeyState(VK_SHIFT) >= 0 && GetKeyState(VK_CONTROL) >= 0)
    {
      SetInsertStateW(!bInsertState, FALSE);
    }
  }
  else if (uMsg == WM_MOUSEWHEEL)
  {
    if (LOWORD(wParam) == MK_CONTROL)
    {
      if ((short)HIWORD(wParam) < 0)
        DoViewFontSizeW(hWndEdit, DECREASE_FONT);
      else
        DoViewFontSizeW(hWndEdit, INCREASE_FONT);
    }
    else
    {
      if ((short)HIWORD(wParam) < 0)
      {
        SCROLLINFO si;

        si.cbSize=sizeof(SCROLLINFO);
        si.fMask=SIF_PAGE|SIF_POS|SIF_RANGE;

        for (i=0; i < 3; ++i)
        {
          GetScrollInfo(hWndEdit, SB_VERT, &si);
          if (si.nPage > 0 && si.nPos + (int)si.nPage < si.nMax)
            SendMessage(hWndEdit, EM_SCROLL, SB_LINEDOWN, 0);
          else
            break;
        }
      }
      else
        for (i=0; i < 3; ++i) SendMessage(hWndEdit, EM_SCROLL, SB_LINEUP, 0);
    }
    return TRUE;
  }
  return CallWindowProcW(OldEditProc, hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewMdiClientProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  int nDropped;
  int i;

  if (uMsg == WM_DROPFILES)
  {
    nDropped=DragQueryFile((HDROP)wParam, 0xFFFFFFFF, szFileBuffer, FILELIST_BUFFER_SIZE);

    for (i=0; i < nDropped; ++i)
    {
      DragQueryFile((HDROP)wParam, i, szFileBuffer, FILELIST_BUFFER_SIZE);
      if (IsFileA(szFileBuffer) == ERROR_FILE_NOT_FOUND)
        OpenDirectoryA(szFileBuffer, TRUE);
      else
        OpenDocumentA(szFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
    }
    DragFinish((HDROP)wParam);
    return TRUE;
  }
  else if (uMsg == WM_LBUTTONDBLCLK)
  {
    if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
    CreateMDIWindow(APP_MDI_CLASS, "", (bMdiMaximize == TRUE)?WS_MAXIMIZE:0, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hMdiClient, hInstance, 0);
  }
  else if (uMsg == WM_MDIDESTROY)
  {
    if ((HWND)wParam)
    {
      if (!(bFileExitError=DoFileExitA())) return TRUE;

      i=SendMessage(hTab, TCM_GETCURSEL, 0, 0);
      SendMessage(hTab, TCM_REMOVEIMAGE, i, 0);
      SendMessage(hTab, TCM_DELETEITEM, i, 0);

      hWndMdiDestroyed=(HWND)wParam;
      SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
      DestroyWindow(GetDlgItem((HWND)wParam, ID_EDIT));

      lpWindowData=(MDIWINDOWDATA *)GetWindowLong((HWND)wParam, GWL_USERDATA);
      if (lpWindowData->hIcon != hIconEmpty) DestroyIcon(lpWindowData->hIcon);
      API_HeapFree(hHeap, 0, (LPVOID)lpWindowData);
    }
  }
  return CallWindowProc(OldMdiClientProc, hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewMdiClientProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  int nDropped;
  int i;

  if (uMsg == WM_DROPFILES)
  {
    nDropped=DragQueryFileW((HDROP)wParam, 0xFFFFFFFF, wszFileBuffer, FILELIST_BUFFER_SIZE);

    for (i=0; i < nDropped; ++i)
    {
      DragQueryFileW((HDROP)wParam, i, wszFileBuffer, FILELIST_BUFFER_SIZE);
      if (IsFileW(wszFileBuffer) == ERROR_FILE_NOT_FOUND)
        OpenDirectoryW(wszFileBuffer, TRUE);
      else
        OpenDocumentW(wszFileBuffer, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
    }
    DragFinish((HDROP)wParam);
    return TRUE;
  }
  else if (uMsg == WM_LBUTTONDBLCLK)
  {
    if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
    CreateMDIWindowW(APP_MDI_CLASSW, L"", (bMdiMaximize == TRUE)?WS_MAXIMIZE:0, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hMdiClient, hInstance, 0);
  }
  else if (uMsg == WM_MDIDESTROY)
  {
    if ((HWND)wParam)
    {
      if (!(bFileExitError=DoFileExitW())) return TRUE;

      i=SendMessage(hTab, TCM_GETCURSEL, 0, 0);
      SendMessage(hTab, TCM_REMOVEIMAGE, i, 0);
      SendMessage(hTab, TCM_DELETEITEM, i, 0);

      hWndMdiDestroyed=(HWND)wParam;
      SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
      DestroyWindow(GetDlgItem((HWND)wParam, ID_EDIT));

      lpWindowData=(MDIWINDOWDATA *)GetWindowLong((HWND)wParam, GWL_USERDATA);
      if (lpWindowData->hIcon != hIconEmpty) DestroyIcon(lpWindowData->hIcon);
      API_HeapFree(hHeap, 0, (LPVOID)lpWindowData);
    }
  }
  return CallWindowProcW(OldMdiClientProc, hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewTabProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_CONTEXTMENU)
  {
    if (lParam != ((UINT)-1))
    {
      RECT rcRect;
      POINT pt;
      HMENU hMdiChildMenu;
      int i;

      pt.x=LOWORD(lParam);
      pt.y=HIWORD(lParam);
      GetWindowRect((HWND)wParam, &rcRect);
      SendMessage(hTab, WM_LBUTTONDOWN, 0, MAKELONG(pt.x - rcRect.left, pt.y - rcRect.top));
      SendMessage(hTab, WM_LBUTTONUP, 0, MAKELONG(pt.x - rcRect.left, pt.y - rcRect.top));

      hMdiChildMenu=GetSystemMenu(hWndMdiActive, FALSE);
      i=TrackPopupMenu(hMdiChildMenu, TPM_NONOTIFY|TPM_RETURNCMD|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWndMdiActive, NULL);
      PostMessage(hWndMdiActive, WM_SYSCOMMAND, i, 0);
    }
    return TRUE;
  }
  else if (uMsg == WM_LBUTTONDBLCLK)
  {
    PostMessage(hMdiClient, WM_MDIDESTROY, (WPARAM)hWndMdiActive, 0);
    return TRUE;
  }
  return CallWindowProc(OldTabProc, hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewTabProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_CONTEXTMENU)
  {
    if (lParam != ((UINT)-1))
    {
      RECT rcRect;
      POINT pt;
      HMENU hMdiChildMenu;
      int i;

      pt.x=LOWORD(lParam);
      pt.y=HIWORD(lParam);
      GetWindowRect((HWND)wParam, &rcRect);
      SendMessage(hTab, WM_LBUTTONDOWN, 0, MAKELONG(pt.x - rcRect.left, pt.y - rcRect.top));
      SendMessage(hTab, WM_LBUTTONUP, 0, MAKELONG(pt.x - rcRect.left, pt.y - rcRect.top));

      hMdiChildMenu=GetSystemMenu(hWndMdiActive, FALSE);
      i=TrackPopupMenu(hMdiChildMenu, TPM_NONOTIFY|TPM_RETURNCMD|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWndMdiActive, NULL);
      PostMessage(hWndMdiActive, WM_SYSCOMMAND, i, 0);
    }
    return TRUE;
  }
  else if (uMsg == WM_LBUTTONDBLCLK)
  {
    PostMessage(hMdiClient, WM_MDIDESTROY, (WPARAM)hWndMdiActive, 0);
    return TRUE;
  }
  return CallWindowProcW(OldTabProc, hWnd, uMsg, wParam, lParam);
}
